
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'ͻ'
' DRUCKEN.BAS          0.23                                     18. 3.2017 '
'͹'
' B E S C H R E I B U N G :                                                '
'Ķ'
' - Programm zur Erstellung historischer Zeittafeln                        '
'   - Programmteil fr verschiedene Ausgabeformate                         '
'͹'
' Q U E L L E N - A N G A B E N :                                          '
'Ķ'
'  9. Gedenket des Vorigen von Alters her; denn ich bin Gott, und keiner   '
' mehr, ein Gott, desgleichen nirgend ist.                                 '
'  10. Der ich verkndige zuvor, was hernach kommen soll, und vorhin, ehe  '
' denn es geschieht, und sage: Mein Anschlag besteht, und ich thue Alles,  '
' was mir gefllt.                                                         '
' (Jesaja 46)                                                              '
'  18. Denn ich sage euch, wahrlich, bis da Himmel und Erde zergehe, wird '
' nicht zergehen der kleinste Buchstabe, noch ein Titel vom Gesetz, bis    '
' da es alles geschehe.                                                   '
' (Matthus 5)                                                             '
'--------------------------------------------------------------------------'
' Bibel                                                                    '
' "Die Bibel, oder die ganze Heilige Schrift Alten und Neuen Testaments"   '
' " nach der deutschen Uebersetzung Dr. Martin Luthers.", Revision durch   '
' Dr. J. Ph. Fresenius, (1751); Druck und Verlag von Heinrich Ludwig       '
' Brnner, Frankfurt am Main, 40.Auflage, (1841)                           '
'                                                                          '
' [Mar2002]                                                                '
' R. Maran: "Das neue Einsteigerbuch Internet - HTML-Webseiten",           '
' Serges Medien Kln, (2002)                                               '
'                                                                          '
' [Kop2002]                                                                '
' H. Kopka: "LaTeX", Band 1: "Einfhrung", Pearson Studium Mnchen,        '
' 3. berarbeitete Auflage, (2002)                                         '
'͹'
' B E A R B E I T U N G :                                                  '
'Ķ'
'  8. 2.2003 - 17. 2.2004      Norbert Sdland                             '
' 18. 4.2007 - 18. 3.2017      Norbert Sdland                             '
'ͼ'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'ͻ'
'                              VORBEREITUNG                                '
'ͼ'

'Ŀ'
'                              Deklarationen                               '
''
 
  DECLARE FUNCTION FuerNutzer$ (Symbol$)
  DECLARE FUNCTION Laden$ (Datei%, DatensatzLaenge%, DateiLaenge&, Position&)
  DECLARE FUNCTION SchnellePosition% (Liste$(), Name$)
  DECLARE FUNCTION SIZEOF% (StrukturName$)
  DECLARE FUNCTION STRLEN% (Text$, EndeZeichen$)
  DECLARE FUNCTION Taste$ ()
  DECLARE FUNCTION Teil$ (Daten$, Variable$)
  DECLARE SUB Ausgabe (Farb%, Frag$, Puff$, Of%, Art$, Ber%, Bereiche%, y%)
  DECLARE SUB Pause ()


'Ŀ'
'                                Variablen                                 '
''

  OPTION BASE 1                 'Felder beginnen beim Eintrag Nr.`1`!
  'OPTION EXPLICIT              'Ntzlich bei VisualBasic

  DIM EingabeDatei$ 'AS STRING
  DIM FormatListe$(8)
  DIM A$
  DIM Programm$
  DIM Puffer$
  DIM PositionsDatei$
  DIM Text$
  DIM Name$
  DIM Daten$
  DIM Variable$
  DIM Gleichzeitig$
  DIM Datum$
  DIM Kopie$
  DIM Align$

  DIM Erfolg%       'AS INTEGER
  DIM Auswahl%
  DIM Leseversuch%
  DIM Konfiguration%
  DIM Position%
  DIM l%
  DIM GlobVarAnzahl%
  DIM DatenLaenge%
  DIM Eingabe%
  DIM y%
  DIM Drucken%
  DIM Vorspann%
  DIM x%
  DIM ascii%
  DIM Zeilen%

  DIM GEL&          'AS LONG
  DIM z&
  DIM Zahl&


'Ŀ'
'                             Erste Befehle                                '
''


  COMMON HistAuswahl%, Arbeitsplatz$, Zeit$, Zaehlweise%
 

  DIM Html%(128)                'AS INTEGER

  REDIM SHARED GVAnfang%(1)             'AS INTEGER
  REDIM SHARED GVLaenge%(1)             'AS INTEGER
  REDIM SHARED GVName$(1)               'AS STRING
  REDIM SHARED GVTyp$(1)                'AS STRING


'Ŀ'
'                               Konstanten                                 '
''

  CONST Konfigurationsdatei$ = "DRUCKEN.CFG"
  CONST DruckFahne$ = "DRUCKEN.JA"


'ͻ'
'                                HAUPTTEIL                                 '
'ͼ'

'Ŀ'
'                            Auswahl des Formats                           '
''

  'Vorbereitung:
  '------------'
  CLEAR , , 4096
  ON ERROR GOTO Fehler
    GOSUB ProgrammStart
   
    'Ausgabe-Format erfragen:
    '-----------------------'
    Erfolg% = 0
    Auswahl% = 1
    WHILE Erfolg% = 0 OR Auswahl% > 0
      CLS
      Ausgabe 2, "(9)... Ausgabeformat auswhlen:", "", 0, "M", 1, 1, 1
      Ausgabe 1, "Arbeitsverzeichnis: ", Arbeitsplatz$, 0, "M", 1, 1, 5
      Ausgabe 1, "Datendatei: ", EingabeDatei$, 0, "M", 1, 1, 6
      FOR y% = 1 TO 8
        IF y% MOD 8 = Auswahl% THEN
          Ausgabe 1, "", FormatListe$(y%), 0, "M", 1, 1, y% + 10
        ELSE
          Ausgabe 1, " " + FormatListe$(y%) + " ", "", 0, "M", 1, 1, y% + 10
        END IF
      NEXT y%
      Ausgabe 1, "Ihre Wahl: ", LTRIM$(STR$(Auswahl%)), 0, "M", 1, 1, 20
      LOCATE CSRLIN, POS(0) - 2

      Erfolg% = 0
      A$ = Taste$
      SELECT CASE ASC(A$)
      CASE ASC("0") TO ASC("5")
        Auswahl% = VAL(A$) MOD 8
        Erfolg% = 1
      CASE 10, 13
        Erfolg% = 1
      CASE 27
        Erfolg% = 0
        Auswahl% = (Auswahl% + 1) MOD 8
        IF Auswahl% = 1 THEN
          Auswahl% = 0
          Erfolg% = 1
        END IF
      END SELECT
      IF ASC(A$) = 0 THEN
        PRINT ASC(RIGHT$(A$, 1))
        SELECT CASE ASC(RIGHT$(A$, 1))
        CASE 59 TO 63
          Auswahl% = ASC(RIGHT$(A$, 1)) - 58
          Erfolg% = 1
        CASE 71, 73   'Home, Bild hoch
          Auswahl% = 1
        CASE 72, 75   'Cursor hoch, Cursor links
          Auswahl% = (Auswahl% + 7) MOD 8
        CASE 77, 80   'Cursor rechts, Cursor runter
          Auswahl% = (Auswahl% + 1) MOD 8
        CASE 79, 81   'Ende, Bild runter
          Auswahl% = 0
        END SELECT
      END IF
      IF Erfolg% = 1 THEN
        Ausgabe 1, "Ihre Wahl: ", LTRIM$(STR$(Auswahl%)), 0, "M", 1, 1, 20
        FOR y% = 1 TO 8
          IF y% MOD 8 = Auswahl% THEN
            Ausgabe 1, "", FormatListe$(y%), 0, "M", 1, 1, y% + 10
          ELSE
            Ausgabe 1, " " + FormatListe$(y%) + " ", "", 0, "M", 1, 1, y% + 10
          END IF
        NEXT y%
        IF Auswahl% <= 5 THEN
          ON Auswahl% GOSUB Code437, LaTeX5pt, LaTeX7pt, LaTeX11pt, CSV
        ELSE
          ON Auswahl% - 5 GOSUB Html, Mathematica
        END IF
      END IF
    WEND

'==========='
Programmende:
'==========='
    'Eventuell Fehlernummer angeben:
    '------------------------------'
    IF ERR > 0 THEN
      PRINT "Fehler Nr."; ERR; " in Zeile"; ERL; "aufgetreten."
      Pause
    END IF

    'Dateien schlieen:
    '-----------------'
    CLOSE

    'Zum aufrufenden Programm zurckkehren:
    '-------------------------------------'
    IF Programm$ <> "" THEN CHAIN Programm$
  SYSTEM
'___________________________ ENDE DES HAUPTTEILS ____________________________'


'ͻ'
'                            FEHLERBEHANDLUNG                              '
'ͼ'

'====='
Fehler:
'====='
  SELECT CASE ERR
  CASE 53               'Datei nicht gefunden:
    SELECT CASE ERL
    CASE 10
      PRINT "Konfigurationsdatei "; Konfigurationsdatei$; " fehlt."
      GOTO Programmende
    CASE 30
      PRINT "Positionsdatei HISTORIK.POS fehlt."
      Leseversuch% = Leseversuch% + 1
      RESUME 21
    CASE ELSE
      Pause
      RESUME NEXT
    END SELECT
  CASE 75               'Pfad- /Datei-Zugriffsfehler:
    SELECT CASE ERL
    CASE 5              'Schreibtests auf `Arbeitsplatz$`
      RESUME NEXT
    CASE ELSE
      Pause
      RESUME
    END SELECT
  CASE 76               'Pfad nicht gefunden:
    SELECT CASE ERL
    CASE 5
      PRINT "Das Arbeitsverzeichnis " + CHR$(34) + Arbeitsplatz$ + CHR$(34)
      PRINT "wurde nicht gefunden. Der Programmteil wird abgebrochen."
      Pause
      GOTO Programmende
    CASE ELSE
      Pause
      RESUME
    END SELECT
  END SELECT

  PRINT "Fehler Nr."; ERR; " in Zeile"; ERL
ON ERROR GOTO 0
GOTO Programmende
'________________________ ENDE DER FEHLERBEHANDLUNG _________________________'


'ͻ'
'                       SUBROUTINEN UND FUNKTIONEN                         '
'ͼ'

'============'
ProgrammStart:
'============'
    CLS
 
    ' Als `Arbeitsplatz$` wird das Arbeitsverzeichnis verwendet, das
    ' %HISTORIKTEMP%, %TEMP% oder %TMP% angibt.
    ' Falls (bei alten DOS-Versionen) gar kein `Arbeitsplatz$` angegeben ist,
    ' wird versucht, auf dem Datentrger, der auch das Programm enthlt, zu
    ' schreiben. Eventuell bricht das Programm ab, wenn der `Arbeitsplatz$`
    ' nicht beschreibbar ist:
    '------------------------------------------------------------------------'
    Arbeitsplatz$ = ENVIRON$("HISTORIKTEMP")
    IF Arbeitsplatz$ = "" THEN
      Arbeitsplatz$ = ENVIRON$("QBASICTEMP")
      IF Arbeitsplatz$ <> "" THEN Arbeitsplatz$ = Arbeitsplatz$ + "\"
5     MKDIR Arbeitsplatz$ + "HISTORIK.TMP"
      Arbeitsplatz$ = Arbeitsplatz$ + "HISTORIK.TMP\"
    ELSE
      IF Arbeitsplatz$ <> "" THEN Arbeitsplatz$ = Arbeitsplatz$ + "\"
    END IF

    'Beschreibbarkeit von `Arbeitsplatz$` prfen:
    '-------------------------------------------'
    BSAVE Arbeitsplatz$ + "HISTORIK.CHK", 0, 0
    KILL Arbeitsplatz$ + "HISTORIK.CHK"
   
    Konfiguration% = FREEFILE
10  OPEN Arbeitsplatz$ + Konfigurationsdatei$ FOR INPUT AS #Konfiguration%
20    LINE INPUT #Konfiguration%, EingabeDatei$
      LINE INPUT #Konfiguration%, Puffer$
      GEL& = VAL(Puffer$)
      LINE INPUT #Konfiguration%, Programm$
    CLOSE #Konfiguration%

    'Strukturpositionen einlesen:
    '---------------------------'
    Position% = FREEFILE
    PRINT "Strukturpositionen von HISTORIK.POS einlesen..."
    Leseversuch% = 1
21  SELECT CASE Leseversuch%
    CASE 1
      PositionsDatei$ = "HISTORIK.POS"
    CASE 2
      PositionsDatei$ = Arbeitsplatz$ + PositionsDatei$
    CASE 3
      Konfiguration% = FREEFILE
      OPEN "HISTORIK.STR" FOR INPUT AS #Konfiguration%
      CLOSE #Konfiguration%
22    OPEN Arbeitsplatz$ + "STRUKTUR.CFG" FOR OUTPUT AS #Konfiguration%
        PRINT #Konfiguration%, "HISTORIK.STR"   'Strukturdatei
        PRINT #Konfiguration%, PositionsDatei$  'tatschliche Positionsdatei
        PRINT #Konfiguration%, "DRUCKEN.BAS"    'Rcksprungprogramm
      CLOSE #Konfiguration%
      CHAIN "STRUKTUR.BAS"
    CASE ELSE
      Pause                             'Programmierfehler!
    END SELECT
30  OPEN PositionsDatei$ FOR INPUT AS #Position%
40    LINE INPUT #Position%, Text$
      l% = STRLEN%(Text$, " ")
      GlobVarAnzahl% = VAL(LEFT$(Text$, l%))
      PRINT LTRIM$(STR$(GlobVarAnzahl%)); " Strukturelemente"
      REDIM SHARED GVAnfang%(GlobVarAnzahl%)          'AS INTEGER
      REDIM SHARED GVLaenge%(GlobVarAnzahl%)          'AS INTEGER
      REDIM SHARED GVName$(GlobVarAnzahl%)            'AS STRING
      REDIM SHARED GVTyp$(GlobVarAnzahl%)             'AS STRING
      FOR y% = 1 TO GlobVarAnzahl%
50      INPUT #Position%, GVAnfang%(y%)
        INPUT #Position%, GVLaenge%(y%)
        INPUT #Position%, GVName$(y%)
        INPUT #Position%, GVTyp$(y%)
      NEXT y%
    CLOSE #Position%
    DatenLaenge% = SIZEOF%("Daten")
    IF DatenLaenge% = 0 THEN ERROR 100

    'Daten-Datei ffnen:
    '------------------'
    Eingabe% = FREEFILE
    Name$ = Arbeitsplatz$ + EingabeDatei$
    OPEN Name$ FOR BINARY ACCESS READ WRITE AS #Eingabe%

    'Liste der Ausgabeformate (ergnzbar):
    '------------------------------------'
    FormatListe$(1) = "(1).. ASCII (Codepage 437)            "
    FormatListe$(2) = "(2).. LaTeX (Leslie Lamport TeX, 5pt) "
    FormatListe$(3) = "(3).. LaTeX (Querformat, 7pt)         "
    FormatListe$(4) = "(4).. LaTeX (grer, 11pt)            "
    FormatListe$(5) = "(5).. Comma Separated Values (CSV)    "
    FormatListe$(6) = "(6).. Hypertext Markup Language (HTML)"
    FormatListe$(7) = "(7).. Mathematica Listenformat        "
    FormatListe$(8) = "(0).. Zurck zum Hauptprogramm        "

    FOR y% = 1 TO 128
      READ Html%(y%)
    NEXT y%

DATA 8962,199,252,233,226,228,224,229,231,234,235,232,239,238,236,196
DATA 197,201,230,198,244,246,242,251,249,255,214,220,162,163,165,8359
DATA 131,225,237,243,250,241,209,170,186,191,8976,172,189,188,161,171
DATA 187,9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565
DATA 9564,9563
DATA 9488,9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568
DATA 9552,9580
DATA 9575,9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604
DATA 9612,9616
DATA 9600,945,223,915,960,931,963,181,964,934,952,937,948,8734,248,949
DATA 8745,8801,177,8805,8804,8992,8993,247,8776,176,149,183,8730,8319,178
DATA 9642

RETURN 'ProgrammStart _______________________________________________________'

'======'
Code437:
'======'

    '1.Ausgabedatei erstellen:
    '------------------------'
    Text$ = "Ausgabedatei " + LEFT$(EingabeDatei$, 8) + ".DR1 wird erstellt."
    Ausgabe 2, Text$, "", 0, "M", 1, 1, 24
    Drucken% = FREEFILE
    Puffer$ = Arbeitsplatz$ + LEFT$(EingabeDatei$, 8) + ".DR1"
90  OPEN Puffer$ FOR OUTPUT AS #Drucken%
      Vorspann% = FREEFILE
91    OPEN "HISTORIK.D_1" FOR INPUT AS #Vorspann%
        WHILE EOF(Vorspann%) = 0
          LINE INPUT #Vorspann%, Text$
          PRINT #Drucken%, Text$
        WEND
      CLOSE #Vorspann%
      FOR z& = 1 TO GEL&
        Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
        FOR y% = 1 TO 6
          Variable$ = "Daten.Datum[" + LTRIM$(STR$(y%)) + "]"
          PRINT #Drucken%, "" + Teil$(Daten$, Variable$);
        NEXT y%
        PRINT #Drucken%, ""
        
        IF z& MOD 60 = 0 OR z& = GEL& THEN
          PRINT #Drucken%, "";
          FOR y% = 2 TO 6
            PRINT #Drucken%, "";
          NEXT y%
          PRINT #Drucken%, ""
          IF z& < GEL& THEN
            PRINT #Drucken%, CHR$(12)
            Vorspann% = FREEFILE
            OPEN "HISTORIK.D_1" FOR INPUT AS #Vorspann%
              WHILE EOF(Vorspann%) = 0
                LINE INPUT #Vorspann%, Text$
                PRINT #Drucken%, Text$
              WEND
            CLOSE #Vorspann%
          END IF
        ELSEIF z& MOD 10 = 0 THEN
          PRINT #Drucken%, "";
          FOR y% = 2 TO 6
            PRINT #Drucken%, "";
          NEXT y%
          PRINT #Drucken%, ""
        ELSEIF z& MOD 5 = 0 THEN
          FOR y% = 1 TO 6
            PRINT #Drucken%, "-------------------------";
          NEXT y%
          PRINT #Drucken%, ""
        END IF
      NEXT z&
    CLOSE #Drucken%

    '2.Ausgabedatei erstellen:
    '------------------------'
    Text$ = "Ausgabedatei " + LEFT$(EingabeDatei$, 8) + ".DR2 wird erstellt."
    Ausgabe 2, Text$, "", 0, "M", 1, 1, 24
    Drucken% = FREEFILE
    Puffer$ = Arbeitsplatz$ + LEFT$(EingabeDatei$, 8) + ".DR2"
    OPEN Puffer$ FOR OUTPUT AS #Drucken%
      Vorspann% = FREEFILE
92    OPEN "HISTORIK.D_2" FOR INPUT AS #Vorspann%
        WHILE EOF(Vorspann%) = 0
          LINE INPUT #Vorspann%, Text$
          PRINT #Drucken%, Text$
        WEND
      CLOSE #Vorspann%
      FOR z& = 1 TO GEL&
        Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
        PRINT #Drucken%, " " + Teil$(Daten$, "Daten.Name") + "  ";
        Puffer$ = FuerNutzer$(Teil$(Daten$, "Daten.V[1].ZP1"))
        PRINT #Drucken%, Puffer$ + " ";
        Puffer$ = FuerNutzer$(Teil$(Daten$, "Daten.V[1].Direkt"))
        PRINT #Drucken%, Puffer$ + " ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.V[1].Name") + "  ";
        Puffer$ = FuerNutzer$(Teil$(Daten$, "Daten.V[1].ZP2"))
        PRINT #Drucken%, Puffer$ + "  ";
        Puffer$ = FuerNutzer$(Teil$(Daten$, "Daten.V[2].ZP1"))
        PRINT #Drucken%, Puffer$ + " ";
        Puffer$ = FuerNutzer$(Teil$(Daten$, "Daten.V[2].Direkt"))
        PRINT #Drucken%, Puffer$ + " ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.V[2].Name") + "  ";
        Puffer$ = FuerNutzer$(Teil$(Daten$, "Daten.V[2].ZP2"))
        PRINT #Drucken%, Puffer$ + "  ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.Quelle") + "  ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.B[1].Tol1") + " ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.B[1].Datum") + "  ";
        Puffer$ = FuerNutzer$(Teil$(Daten$, "Daten.B[1].ZP1"))
        PRINT #Drucken%, Puffer$ + " ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.B[1].Name") + " "
       
        IF z& MOD 60 = 0 OR z& = GEL& THEN
          PRINT #Drucken%, "";
          PRINT #Drucken%, "";
          PRINT #Drucken%, "";
          PRINT #Drucken%, "ͼ"
          IF z& < GEL& THEN
            PRINT #Drucken%, CHR$(12)
            Vorspann% = FREEFILE
            OPEN "HISTORIK.D_2" FOR INPUT AS #Vorspann%
              WHILE EOF(Vorspann%) = 0
                LINE INPUT #Vorspann%, Text$
                PRINT #Drucken%, Text$
              WEND
            CLOSE #Vorspann%
          END IF
        ELSEIF z& MOD 10 = 0 THEN
          PRINT #Drucken%, "";
          PRINT #Drucken%, "";
          PRINT #Drucken%, "";
          PRINT #Drucken%, "Ķ"
        ELSEIF z& MOD 5 = 0 THEN
          PRINT #Drucken%, "---------------------------------------------";
          PRINT #Drucken%, "-------------------------------------------";
          PRINT #Drucken%, "---------------------------------------------";
          PRINT #Drucken%, "------------------"
        END IF
      NEXT z&
    CLOSE #Drucken%
  
    '3.Ausgabedatei erstellen:
    '------------------------'
    Text$ = "Ausgabedatei " + LEFT$(EingabeDatei$, 8) + ".DR3 wird erstellt."
    Ausgabe 2, Text$, "", 0, "M", 1, 1, 24
    Drucken% = FREEFILE
    Puffer$ = Arbeitsplatz$ + LEFT$(EingabeDatei$, 8) + ".DR3"
    OPEN Puffer$ FOR OUTPUT AS #Drucken%
      Vorspann% = FREEFILE
93    OPEN "HISTORIK.D_3" FOR INPUT AS #Vorspann%
        WHILE EOF(Vorspann%) = 0
          LINE INPUT #Vorspann%, Text$
          PRINT #Drucken%, Text$
        WEND
      CLOSE #Vorspann%
      FOR z& = 1 TO GEL&
        Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
        Puffer$ = FuerNutzer$(Teil$(Daten$, "Daten.B[1].ZP2"))
        PRINT #Drucken%, " " + Puffer$ + "  ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.B[1].Tol2") + " ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.B[1].Dauer") + "  ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.B[1].Quelle") + "  ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.B[2].Tol1") + " ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.B[2].Datum") + "  ";
        Puffer$ = FuerNutzer$(Teil$(Daten$, "Daten.B[2].ZP1"))
        PRINT #Drucken%, Puffer$ + " ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.B[2].Name") + "  ";
        Puffer$ = FuerNutzer$(Teil$(Daten$, "Daten.B[2].ZP2"))
        PRINT #Drucken%, Puffer$ + "  ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.B[2].Tol2") + " ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.B[2].Dauer") + "  ";
        Gleichzeitig$ = FuerNutzer$(Teil$(Daten$, "Daten.Gleichzeitig"))
        PRINT #Drucken%, MID$(Gleichzeitig$, 1, 1) + " ";
        PRINT #Drucken%, MID$(Gleichzeitig$, 2, 1) + " ";
        PRINT #Drucken%, MID$(Gleichzeitig$, 3, 1) + "  ";
        PRINT #Drucken%, MID$(Gleichzeitig$, 4, 1) + " ";
        PRINT #Drucken%, MID$(Gleichzeitig$, 5, 1) + "  ";
        PRINT #Drucken%, Teil$(Daten$, "Daten.B[2].Quelle") + " "
      
        IF z& MOD 60 = 0 OR z& = GEL& THEN
          PRINT #Drucken%, "";
          PRINT #Drucken%, "";
          PRINT #Drucken%, "";
          PRINT #Drucken%, "ͼ"
          IF z& < GEL& THEN
            PRINT #Drucken%, CHR$(12)
            Vorspann% = FREEFILE
            OPEN "HISTORIK.D_3" FOR INPUT AS #Vorspann%
              WHILE EOF(Vorspann%) = 0
                LINE INPUT #Vorspann%, Text$
                PRINT #Drucken%, Text$
              WEND
            CLOSE #Vorspann%
          END IF
        ELSEIF z& MOD 10 = 0 THEN
          PRINT #Drucken%, "";
          PRINT #Drucken%, "";
          PRINT #Drucken%, "";
          PRINT #Drucken%, "Ķ"
        ELSEIF z& MOD 5 = 0 THEN
          PRINT #Drucken%, "--------------------------------------------";
          PRINT #Drucken%, "---------------------------------------------";
          PRINT #Drucken%, "------------------------------------------";
          PRINT #Drucken%, "------------------"
        END IF
      NEXT z&
    CLOSE #Drucken%

    LOCATE 24, 1
    PRINT SPACE$(80);
    Ausgabe 2, "Zum Drucken Programm verlassen.", "", 0, "M", 1, 1, 24
    Pause
    Drucken% = FREEFILE
    OPEN Arbeitsplatz$ + DruckFahne$ FOR OUTPUT AS #Drucken%
    CLOSE #Drucken%
    '------------------------------------------------------------------------'
    ' Eigentlich sollte hier der Ausdruck ber QBASIC programmiert sein.
    ' Leider kann das LPRINT von QBASIC nur 80 Zeichen je Zeile ausgeben.
    ' Selbst das Primitiv-BASIC vom Alpatronic PC war da erfolgreicher...
    '
    ' Fr die Einstellung des Druckes ist Schmaldruck, Tiefstellung und er=
    ' weiterter Zeichensatz ntig, damit 160 Zeichen je Zeile gedruckt werden.
    ' Fr den EPSON LQ 500 sieht die Einstellung des Druckers so aus:
    ' LPRINT CHR$(27) + "@" + CHR$(15) + CHR$(27) + CHR$(83) + CHR$(1);
    ' LPRINT CHR$(27) + "l" + CHR$(0) + CHR$(27) + "t" + CHR$(1);
    ' LPRINT CHR$(27) + "0" + CHR$(17);
    ' Danach kann ber den DOS-Befehl "PRINT" gedruckt werden.
    '
    ' Unter Windows ist der Befehl `PRINT` abgeschafft worden!
    ' Es wird empfohlen, auf die anderen Datenformate auszuweichen.
    '------------------------------------------------------------------------'
  
RETURN 'Code437 _____________________________________________________________'

'======='
LaTeX5pt:
'======='
  Text$ = "Ausgabedatei " + LEFT$(EingabeDatei$, 8) + ".TeX wird erstellt."
  Ausgabe 2, Text$, "", 0, "M", 1, 1, 24
  Drucken% = FREEFILE
  Puffer$ = Arbeitsplatz$ + LEFT$(EingabeDatei$, 8) + ".TeX"
  OPEN Puffer$ FOR OUTPUT AS #Drucken%
    PRINT #Drucken%, "\documentclass[10pt]{article}"
    PRINT #Drucken%, "\usepackage{geometry,german}"
    PRINT #Drucken%, "\usepackage[cp437de]{inputenc}"
    PRINT #Drucken%, "\usepackage{latexsym}"
    PRINT #Drucken%, "\setlength{\parindent}{0pt}"
    PRINT #Drucken%, "\setlength{\topmargin}{-5.4mm}"
    PRINT #Drucken%, "\setlength{\headheight}{0mm}"
    PRINT #Drucken%, "\setlength{\headsep}{0mm}"
    PRINT #Drucken%, "\setlength{\topskip}{0mm}"
    PRINT #Drucken%, "\setlength{\textheight}{229.4mm}"
    PRINT #Drucken%, "\setlength{\oddsidemargin}{-5.4mm}"
    PRINT #Drucken%, "\setlength{\evensidemargin}{-5.4mm}"
    PRINT #Drucken%, "\setlength{\textwidth}{175.9mm}"
    PRINT #Drucken%, "\begin{document}\tt"
   
    Zeilen% = 100
    GOSUB LaTeXdateiErstellen

    PRINT #Drucken%, "\end{document}"
  CLOSE #Drucken%

  LOCATE 24, 1
  PRINT SPACE$(80);
  Ausgabe 2, "Zum bersetzen Programm verlassen.", "", 0, "M", 1, 1, 24
  Pause
RETURN 'LaTeX5pt ____________________________________________________________'

'======='
LaTeX7pt:
'======='
  Text$ = "Ausgabedatei " + LEFT$(EingabeDatei$, 8) + ".TeX wird erstellt."
  Ausgabe 2, Text$, "", 0, "M", 1, 1, 24
  Drucken% = FREEFILE
  Puffer$ = Arbeitsplatz$ + LEFT$(EingabeDatei$, 8) + ".TeX"
  OPEN Puffer$ FOR OUTPUT AS #Drucken%
    PRINT #Drucken%, "\documentclass[10pt,landscape]{article}"
    PRINT #Drucken%, "\usepackage{geometry,german}"
    PRINT #Drucken%, "\usepackage[cp437de]{inputenc}"
    PRINT #Drucken%, "\usepackage{latexsym}"
    PRINT #Drucken%, "\setlength{\parindent}{0pt}"
    PRINT #Drucken%, "\setlength{\topmargin}{-5.4mm}"
    PRINT #Drucken%, "\setlength{\headheight}{0mm}"
    PRINT #Drucken%, "\setlength{\headsep}{0mm}"
    PRINT #Drucken%, "\setlength{\topskip}{0mm}"
    PRINT #Drucken%, "\setlength{\textheight}{160mm}"
    PRINT #Drucken%, "\setlength{\oddsidemargin}{-5.4mm}"
    PRINT #Drucken%, "\setlength{\evensidemargin}{-5.4mm}"
    PRINT #Drucken%, "\setlength{\textwidth}{239.4mm}"
    PRINT #Drucken%, "\begin{document}\tt"
  
    Zeilen% = 50
    GOSUB LaTeXdateiErstellen

    PRINT #Drucken%, "\end{document}"
  CLOSE #Drucken%

  LOCATE 24, 1
  PRINT SPACE$(80);
  Ausgabe 2, "Zum bersetzen Programm verlassen.", "", 0, "M", 1, 1, 24
  Pause
RETURN 'LaTeX7pt ____________________________________________________________'

'========'
LaTeX11pt:
'========'
  Text$ = "Ausgabedatei " + LEFT$(EingabeDatei$, 8) + ".TeX wird erstellt."
  Ausgabe 2, Text$, "", 0, "M", 1, 1, 24
  Drucken% = FREEFILE
  Puffer$ = Arbeitsplatz$ + LEFT$(EingabeDatei$, 8) + ".TeX"
  OPEN Puffer$ FOR OUTPUT AS #Drucken%
    PRINT #Drucken%, "\documentclass[11pt]{article}"
    PRINT #Drucken%, "\usepackage{geometry,german}"
    PRINT #Drucken%, "\usepackage[cp437de]{inputenc}"
    PRINT #Drucken%, "\usepackage{latexsym}"
    PRINT #Drucken%, "\setlength{\parindent}{0pt}"
    PRINT #Drucken%, "\setlength{\topmargin}{-5.4mm}"
    PRINT #Drucken%, "\setlength{\headheight}{0mm}"
    PRINT #Drucken%, "\setlength{\headsep}{0mm}"
    PRINT #Drucken%, "\setlength{\topskip}{0mm}"
    PRINT #Drucken%, "\setlength{\textheight}{229.4mm}"
    PRINT #Drucken%, "\setlength{\oddsidemargin}{-5.4mm}"
    PRINT #Drucken%, "\setlength{\evensidemargin}{-5.4mm}"
    PRINT #Drucken%, "\setlength{\textwidth}{180mm}"
    PRINT #Drucken%, "\begin{document}\tt"
    Zeilen% = 40
    FOR z& = 1 TO GEL&
      Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
      IF (z& - 1) MOD Zeilen% = 0 THEN
        IF z& > 1 THEN
          PRINT #Drucken%, "\newpage"
        END IF
        Text$ = "Datierungen (1/6) von " + RTRIM$(LEFT$(EingabeDatei$, 8))
        Text$ = Text$ + ".HQL ("
        Zahl& = ((z& - 1) - ((z& - 1) MOD Zeilen%)) / Zeilen% + 1
        Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "/"
        Zahl& = ((GEL& - 1) - ((GEL& - 1) MOD Zeilen%)) / Zeilen% + 1
        Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "):"
        GOSUB LaTeXAusgabe
        PRINT #Drucken%, "\\"
        PRINT #Drucken%, "\setlength{\rightmargin}{\leftmargin}"
        Text$ = "\begin{tabular}{*{3}{|c@{}r@{}l@{}r@{}l@{}r@{}l@{}c@{}"
        Text$ = Text$ + "c@{}r@{}l@{}r@{}l@{}r@{}l}|} \hline"
        PRINT #Drucken%, Text$
        PRINT #Drucken%, "\multicolumn{15}{|c}{Lebensanfang      [$*$] } &"
        PRINT #Drucken%, "\multicolumn{15}{|c}{1.Wirkungsanfang  [A] } &"
        PRINT #Drucken%, "\multicolumn{15}{|c|}{2.Wirkungsanfang [W] }\\"
        PRINT #Drucken%, "\hline"
      ELSEIF (z& - 1) MOD 5 = 0 THEN
        PRINT #Drucken%, "\hline"
      END IF
      FOR x% = 1 TO 3
        Variable$ = "Daten.Datum[" + LTRIM$(STR$(x%)) + "]"
        Datum$ = Teil$(Daten$, Variable$)
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.VZ")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.Jahr")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.JS")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.Monat")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.MS")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.Tag")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.TS")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Status")
        GOSUB LaTeXTabelleSonderzeichen
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.VZ")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.Jahr")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.JS")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.Monat")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.MS")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.Tag")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.TS")
        GOSUB LaTeXAusgabe
        IF x% < 3 THEN
          PRINT #Drucken%, " & "
        ELSE
          PRINT #Drucken%, " \\"
        END IF
      NEXT x%
      IF (z& - 1) MOD Zeilen% = Zeilen% - 1 OR z& = GEL& THEN
        PRINT #Drucken%, "\hline"
        PRINT #Drucken%, "\end{tabular} \hspace*{\fill}"
      END IF
    NEXT z&
 
    FOR z& = 1 TO GEL&
      Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
      IF (z& - 1) MOD Zeilen% = 0 THEN
        PRINT #Drucken%, "\newpage"
        Text$ = "Datierungen (2/6) von " + RTRIM$(LEFT$(EingabeDatei$, 8))
        Text$ = Text$ + ".HQL ("
        Zahl& = ((z& - 1) - ((z& - 1) MOD Zeilen%)) / Zeilen% + 1
        Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "/"
        Zahl& = ((GEL& - 1) - ((GEL& - 1) MOD Zeilen%)) / Zeilen% + 1
        Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "):"
        GOSUB LaTeXAusgabe
        PRINT #Drucken%, "\\"
        PRINT #Drucken%, "\setlength{\rightmargin}{\leftmargin}"
        Text$ = "\begin{tabular}{*{3}{|c@{}r@{}l@{}r@{}l@{}r@{}l@{}c@{}"
        Text$ = Text$ + "c@{}r@{}l@{}r@{}l@{}r@{}l}|} \hline"
        PRINT #Drucken%, Text$
        PRINT #Drucken%, "\multicolumn{15}{|c}{2.Wirkungsende   [X] } &"
        PRINT #Drucken%, "\multicolumn{15}{|c}{1.Wirkungsende   [E] } &"
        PRINT #Drucken%, "\multicolumn{15}{|c|}{Lebensende      [+] }\\"
        PRINT #Drucken%, "\hline"
      ELSEIF (z& - 1) MOD 5 = 0 THEN
        PRINT #Drucken%, "\hline"
      END IF
      FOR x% = 4 TO 6
        Variable$ = "Daten.Datum[" + LTRIM$(STR$(x%)) + "]"
        Datum$ = Teil$(Daten$, Variable$)
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.VZ")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.Jahr")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.JS")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.Monat")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.MS")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.Tag")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Minimum.TS")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Status")
        GOSUB LaTeXTabelleSonderzeichen
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.VZ")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.Jahr")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.JS")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.Monat")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.MS")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.Tag")
        GOSUB LaTeXTabelle
        Text$ = Teil$(Datum$, "Zeitangabe.Maximum.TS")
        GOSUB LaTeXAusgabe
        IF x% < 6 THEN
          PRINT #Drucken%, " & "
        ELSE
          PRINT #Drucken%, " \\"
        END IF
      NEXT x%
      IF (z& - 1) MOD Zeilen% = Zeilen% - 1 OR z& = GEL& THEN
        PRINT #Drucken%, "\hline"
        PRINT #Drucken%, "\end{tabular} \hspace*{\fill}"
      END IF
    NEXT z&
  
    FOR z& = 1 TO GEL&
      Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
      IF (z& - 1) MOD Zeilen% = 0 THEN
        PRINT #Drucken%, "\newpage"
        Text$ = "Inhalt (3/6) von " + RTRIM$(LEFT$(EingabeDatei$, 8))
        Text$ = Text$ + ".HQL ("
        Zahl& = ((z& - 1) - ((z& - 1) MOD Zeilen%)) / Zeilen% + 1
        Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "/"
        Zahl& = ((GEL& - 1) - ((GEL& - 1) MOD Zeilen%)) / Zeilen% + 1
        Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "):"
        GOSUB LaTeXAusgabe
        PRINT #Drucken%, "\\"
        PRINT #Drucken%, "\setlength{\rightmargin}{\leftmargin}"
        Text$ = "\begin{tabular}{|l|"
        Text$ = Text$ + "c@{\hspace{0.5em}}c@{\hspace{0.5em}}"
        Text$ = Text$ + "l@{\hspace{0.5em}}c|"
        Text$ = Text$ + "c@{\hspace{0.5em}}c@{\hspace{0.5em}}l"
        Text$ = Text$ + "@{\hspace{0.5em}}c|"
        Text$ = Text$ + "} \hline"
        PRINT #Drucken%, Text$
        PRINT #Drucken%, "\multicolumn{1}{|c}{Name /Ereignis} &"
        PRINT #Drucken%, "\multicolumn{4}{|c}{1.Vorgnger} &"
        PRINT #Drucken%, "\multicolumn{4}{|c|}{2.Vorgnger} \\"
        PRINT #Drucken%, "\hline"
      ELSEIF (z& - 1) MOD 5 = 0 THEN
        PRINT #Drucken%, "\hline"
      END IF
      Text$ = Teil$(Daten$, "Daten.Name")
      GOSUB LaTeXTabelle
      Text$ = FuerNutzer$(Teil$(Daten$, "Daten.V[1].ZP1"))
      GOSUB LaTeXTabelleSonderzeichen
      Text$ = FuerNutzer$(Teil$(Daten$, "Daten.V[1].Direkt"))
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.V[1].Name")
      GOSUB LaTeXTabelle
      Text$ = FuerNutzer$(Teil$(Daten$, "Daten.V[1].ZP2"))
      GOSUB LaTeXTabelleSonderzeichen
      Text$ = FuerNutzer$(Teil$(Daten$, "Daten.V[2].ZP1"))
      GOSUB LaTeXTabelleSonderzeichen
      Text$ = FuerNutzer$(Teil$(Daten$, "Daten.V[2].Direkt"))
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.V[2].Name")
      GOSUB LaTeXTabelle
      Text$ = FuerNutzer$(Teil$(Daten$, "Daten.V[2].ZP2"))
      GOSUB LaTeXAusgabeSonderzeichen
      PRINT #Drucken%, " \\"
      IF (z& - 1) MOD Zeilen% = Zeilen% - 1 OR z& = GEL& THEN
        PRINT #Drucken%, "\hline"
        PRINT #Drucken%, "\end{tabular} \hspace*{\fill}"
      END IF
    NEXT z&

    FOR z& = 1 TO GEL&
      Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
      IF (z& - 1) MOD Zeilen% = 0 THEN
        PRINT #Drucken%, "\newpage"
        Text$ = "Inhalt (4/6) von " + RTRIM$(LEFT$(EingabeDatei$, 8))
        Text$ = Text$ + ".HQL ("
        Zahl& = ((z& - 1) - ((z& - 1) MOD Zeilen%)) / Zeilen% + 1
        Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "/"
        Zahl& = ((GEL& - 1) - ((GEL& - 1) MOD Zeilen%)) / Zeilen% + 1
        Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "):"
        GOSUB LaTeXAusgabe
        PRINT #Drucken%, "\\"
        PRINT #Drucken%, "\setlength{\rightmargin}{\leftmargin}"
        Text$ = "\begin{tabular}{|l|"
        Text$ = Text$ + "c@{\hspace{0.5em}}r@{}l@{\hspace{0.5em}}"
        Text$ = Text$ + "r@{}l@{ }r@{}l|"
        Text$ = Text$ + "c@{\hspace{0.5em}}l|} \hline"
        PRINT #Drucken%, Text$
        PRINT #Drucken%, "\multicolumn{1}{|c}{1.Quelle} &"
        PRINT #Drucken%, "\multicolumn{7}{|c}{1.Bezugsdatum} &"
        PRINT #Drucken%, "\multicolumn{2}{|c|}{1.Bezugsname} \\"
        PRINT #Drucken%, "\hline"
      ELSEIF (z& - 1) MOD 5 = 0 THEN
        PRINT #Drucken%, "\hline"
      END IF
      Text$ = Teil$(Daten$, "Daten.Quelle")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[1].Tol1")
      GOSUB LaTeXTabelleSonderzeichen
      Text$ = Teil$(Daten$, "Daten.B[1].Datum.Jahr")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[1].Datum.JS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[1].Datum.Monat")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[1].Datum.MS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[1].Datum.Tag")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[1].Datum.TS")
      GOSUB LaTeXTabelle
      Text$ = FuerNutzer$(Teil$(Daten$, "Daten.B[1].ZP1"))
      GOSUB LaTeXTabelleSonderzeichen
      Text$ = Teil$(Daten$, "Daten.B[1].Name")
      GOSUB LaTeXAusgabe
      PRINT #Drucken%, " \\"
      IF (z& - 1) MOD Zeilen% = Zeilen% - 1 OR z& = GEL& THEN
        PRINT #Drucken%, "\hline"
        PRINT #Drucken%, "\end{tabular} \hspace*{\fill}"
      END IF
    NEXT z&
 
    FOR z& = 1 TO GEL&
      Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
      IF (z& - 1) MOD Zeilen% = 0 THEN
        PRINT #Drucken%, "\newpage"
        Text$ = "Inhalt (5/6) von " + RTRIM$(LEFT$(EingabeDatei$, 8))
        Text$ = Text$ + ".HQL ("
        Zahl& = ((z& - 1) - ((z& - 1) MOD Zeilen%)) / Zeilen% + 1
        Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "/"
        Zahl& = ((GEL& - 1) - ((GEL& - 1) MOD Zeilen%)) / Zeilen% + 1
        Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "):"
        GOSUB LaTeXAusgabe
        PRINT #Drucken%, "\\"
        PRINT #Drucken%, "\setlength{\rightmargin}{\leftmargin}"
        Text$ = "\begin{tabular}{|c@{\hspace{0.5em}}c@{\hspace{0.5em}}r@{}l"
        Text$ = Text$ + "@{\hspace{0.5em}}r@{}l@{\hspace{0.5em}}r@{}l|l|"
        Text$ = Text$ + "c@{\hspace{0.5em}}r@{}l@{\hspace{0.5em}}r@{}l"
        Text$ = Text$ + "@{\hspace{0.5em}}r@{}l|}"
        Text$ = Text$ + " \hline"
        PRINT #Drucken%, Text$
        PRINT #Drucken%, "\multicolumn{8}{|c}{1.Dauer} &"
        PRINT #Drucken%, "\multicolumn{1}{|c}{2.Quelle} &"
        PRINT #Drucken%, "\multicolumn{7}{|c|}{2.Bezugsdatum} \\"
        PRINT #Drucken%, "\hline"
      ELSEIF (z& - 1) MOD 5 = 0 THEN
        PRINT #Drucken%, "\hline"
      END IF
      Text$ = FuerNutzer$(Teil$(Daten$, "Daten.B[1].ZP2"))
      GOSUB LaTeXTabelleSonderzeichen
      Text$ = Teil$(Daten$, "Daten.B[1].Tol2")
      GOSUB LaTeXTabelleSonderzeichen
      Text$ = Teil$(Daten$, "Daten.B[1].Dauer.Jahr")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[1].Dauer.JS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[1].Dauer.Monat")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[1].Dauer.MS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[1].Dauer.Tag")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[1].Dauer.TS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[1].Quelle")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[2].Tol1")
      GOSUB LaTeXTabelleSonderzeichen
      Text$ = Teil$(Daten$, "Daten.B[2].Datum.Jahr")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[2].Datum.JS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[2].Datum.Monat")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[2].Datum.MS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[2].Datum.Tag")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[2].Datum.TS")
      GOSUB LaTeXAusgabe
      PRINT #Drucken%, " \\"
      IF (z& - 1) MOD Zeilen% = Zeilen% - 1 OR z& = GEL& THEN
        PRINT #Drucken%, "\hline"
        PRINT #Drucken%, "\end{tabular}"
      END IF
    NEXT z&

    FOR z& = 1 TO GEL&
      Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
      IF (z& - 1) MOD Zeilen% = 0 THEN
        PRINT #Drucken%, "\newpage"
        Text$ = "Inhalt (6/6) von " + RTRIM$(LEFT$(EingabeDatei$, 8))
        Text$ = Text$ + ".HQL ("
        Zahl& = ((z& - 1) - ((z& - 1) MOD Zeilen%)) / Zeilen% + 1
        Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "/"
        Zahl& = ((GEL& - 1) - ((GEL& - 1) MOD Zeilen%)) / Zeilen% + 1
        Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "):"
        GOSUB LaTeXAusgabe
        PRINT #Drucken%, "\\"
        PRINT #Drucken%, "\setlength{\rightmargin}{\leftmargin}"
        Text$ = "\begin{tabular}{|c@{\hspace{0.5em}}l|"
        Text$ = Text$ + "c@{\hspace{0.5em}}c@{\hspace{0.5em}}r@{}l"
        Text$ = Text$ + "@{\hspace{0.5em}}"
        Text$ = Text$ + "r@{}l@{\hspace{0.5em}}r@{}l|"
        Text$ = Text$ + "l@{\hspace{0.5em}}l|l|}"
        Text$ = Text$ + " \hline"
        PRINT #Drucken%, Text$
        PRINT #Drucken%, "\multicolumn{2}{|c}{2.Bezugsname} &"
        PRINT #Drucken%, "\multicolumn{8}{|c}{2.Dauer} &"
        PRINT #Drucken%, "\multicolumn{2}{|c}{Zugleich} &"
        PRINT #Drucken%, "\multicolumn{1}{|c|}{3.Quelle} \\"
        PRINT #Drucken%, "\hline"
      ELSEIF (z& - 1) MOD 5 = 0 THEN
        PRINT #Drucken%, "\hline"
      END IF
      Text$ = FuerNutzer$(Teil$(Daten$, "Daten.B[2].ZP1"))
      GOSUB LaTeXTabelleSonderzeichen
      Text$ = Teil$(Daten$, "Daten.B[2].Name")
      GOSUB LaTeXTabelle
      Text$ = FuerNutzer$(Teil$(Daten$, "Daten.B[2].ZP2"))
      GOSUB LaTeXTabelleSonderzeichen
      Text$ = Teil$(Daten$, "Daten.B[2].Tol2")
      GOSUB LaTeXTabelleSonderzeichen
      Text$ = Teil$(Daten$, "Daten.B[2].Dauer.Jahr")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[2].Dauer.JS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[2].Dauer.Monat")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[2].Dauer.MS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[2].Dauer.Tag")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[2].Dauer.TS")
      GOSUB LaTeXTabelle
      Gleichzeitig$ = FuerNutzer$(Teil$(Daten$, "Daten.Gleichzeitig"))
      Text$ = LEFT$(Gleichzeitig$, 3)
      GOSUB LaTeXTabelle
      Text$ = RIGHT$(Gleichzeitig$, 2)
      GOSUB LaTeXTabelle
      Text$ = Teil$(Daten$, "Daten.B[2].Quelle")
      GOSUB LaTeXAusgabe
      PRINT #Drucken%, " \\"
      IF (z& - 1) MOD Zeilen% = Zeilen% - 1 OR z& = GEL& THEN
        PRINT #Drucken%, "\hline"
        PRINT #Drucken%, "\end{tabular}"
      END IF
    NEXT z&
   
    PRINT #Drucken%, "\end{document}"
  CLOSE #Drucken%

  LOCATE 24, 1
  PRINT SPACE$(80);
  Ausgabe 2, "Zum bersetzen Programm verlassen.", "", 0, "M", 1, 1, 24
  Pause
RETURN 'LaTeX11pt ___________________________________________________________'
   
'=================='
LaTeXdateiErstellen:
'=================='
  FOR z& = 1 TO GEL&
    Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
    IF (z& - 1) MOD Zeilen% = 0 THEN
      IF z& > 1 THEN
        PRINT #Drucken%, "\newpage"
      END IF
      Text$ = "Datierungen (1/3) von " + RTRIM$(LEFT$(EingabeDatei$, 8))
      Text$ = Text$ + ".HQL ("
      Zahl& = ((z& - 1) - ((z& - 1) MOD Zeilen%)) / Zeilen% + 1
      Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "/"
      Zahl& = ((GEL& - 1) - ((GEL& - 1) MOD Zeilen%)) / Zeilen% + 1
      Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "):"
      GOSUB LaTeXAusgabe
      PRINT #Drucken%, "\\"
      IF Zeilen% = 100 THEN
        PRINT #Drucken%, "\begin{tiny}"
      ELSE
        PRINT #Drucken%, "\begin{scriptsize}"
      END IF
      PRINT #Drucken%, "\setlength{\rightmargin}{\leftmargin}"
      Text$ = "\begin{tabular}{*{6}{|c@{}r@{}l@{}r@{}l@{}r@{}l@{}c@{}"
      Text$ = Text$ + "c@{}r@{}l@{}r@{}l@{}r@{}l}|} \hline"
      PRINT #Drucken%, Text$
      PRINT #Drucken%, "\multicolumn{15}{|c}{Lebensanfang     [$*$] } &"
      PRINT #Drucken%, "\multicolumn{15}{|c}{1.Wirkungsanfang [A] } &"
      PRINT #Drucken%, "\multicolumn{15}{|c}{2.Wirkungsanfang [W] } &"
      PRINT #Drucken%, "\multicolumn{15}{|c}{2.Wirkungsende   [X] } &"
      PRINT #Drucken%, "\multicolumn{15}{|c}{1.Wirkungsende   [E] } &"
      PRINT #Drucken%, "\multicolumn{15}{|c|}{Lebensende      [+] }\\"
      PRINT #Drucken%, "\hline"
    ELSEIF (z& - 1) MOD (Zeilen% / 10) = 0 THEN
      PRINT #Drucken%, "\hline"
    END IF
    FOR x% = 1 TO 6
      Variable$ = "Daten.Datum[" + LTRIM$(STR$(x%)) + "]"
      Datum$ = Teil$(Daten$, Variable$)
      Text$ = Teil$(Datum$, "Zeitangabe.Minimum.VZ")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Minimum.Jahr")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Minimum.JS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Minimum.Monat")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Minimum.MS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Minimum.Tag")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Minimum.TS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Status")
      GOSUB LaTeXTabelleSonderzeichen
      Text$ = Teil$(Datum$, "Zeitangabe.Maximum.VZ")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Maximum.Jahr")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Maximum.JS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Maximum.Monat")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Maximum.MS")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Maximum.Tag")
      GOSUB LaTeXTabelle
      Text$ = Teil$(Datum$, "Zeitangabe.Maximum.TS")
      GOSUB LaTeXAusgabe
      IF x% < 6 THEN
        PRINT #Drucken%, " & "
      ELSE
        PRINT #Drucken%, " \\"
      END IF
    NEXT x%
    IF (z& - 1) MOD Zeilen% = Zeilen% - 1 OR z& = GEL& THEN
      PRINT #Drucken%, "\hline"
      PRINT #Drucken%, "\end{tabular} \hspace*{\fill}"
      IF Zeilen% = 100 THEN
        PRINT #Drucken%, "\end{tiny}"
      ELSE
        PRINT #Drucken%, "\end{scriptsize}"
      END IF
    END IF
  NEXT z&
  
  FOR z& = 1 TO GEL&
    Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
    IF (z& - 1) MOD Zeilen% = 0 THEN
      PRINT #Drucken%, "\newpage"
      Text$ = "Inhalt (2/3) von " + RTRIM$(LEFT$(EingabeDatei$, 8))
      Text$ = Text$ + ".HQL ("
      Zahl& = ((z& - 1) - ((z& - 1) MOD Zeilen%)) / Zeilen% + 1
      Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "/"
      Zahl& = ((GEL& - 1) - ((GEL& - 1) MOD Zeilen%)) / Zeilen% + 1
      Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "):"
      GOSUB LaTeXAusgabe
      PRINT #Drucken%, "\\"
      IF Zeilen% = 100 THEN
        PRINT #Drucken%, "\begin{tiny}"
      ELSE
        PRINT #Drucken%, "\begin{scriptsize}"
      END IF
      PRINT #Drucken%, "\setlength{\rightmargin}{\leftmargin}"
      Text$ = "\begin{tabular}{|l|"
      Text$ = Text$ + "c@{\hspace{0.5em}}c@{\hspace{0.5em}}l"
      Text$ = Text$ + "@{\hspace{0.5em}}c|"
      Text$ = Text$ + "c@{\hspace{0.5em}}c@{\hspace{0.5em}}l"
      Text$ = Text$ + "@{\hspace{0.5em}}c|"
      Text$ = Text$ + "l|c@{\hspace{0.5em}}r@{}l@{\hspace{0.5em}}"
      Text$ = Text$ + "r@{}l@{ }r@{}l|c@{\hspace{0.5em}}l|} \hline"
      PRINT #Drucken%, Text$
      PRINT #Drucken%, "\multicolumn{1}{|c}{Name /Ereignis} &"
      PRINT #Drucken%, "\multicolumn{4}{|c}{1.Vorgnger} &"
      PRINT #Drucken%, "\multicolumn{4}{|c}{2.Vorgnger} &"
      PRINT #Drucken%, "\multicolumn{1}{|c}{1.Quelle} &"
      PRINT #Drucken%, "\multicolumn{7}{|c}{1.Bezugsdatum} &"
      PRINT #Drucken%, "\multicolumn{2}{|c|}{1.Bezugsname} \\"
      PRINT #Drucken%, "\hline"
    ELSEIF (z& - 1) MOD (Zeilen% / 10) = 0 THEN
      PRINT #Drucken%, "\hline"
    END IF
    Text$ = Teil$(Daten$, "Daten.Name")
    GOSUB LaTeXTabelle
    Text$ = FuerNutzer$(Teil$(Daten$, "Daten.V[1].ZP1"))
    GOSUB LaTeXTabelleSonderzeichen
    Text$ = FuerNutzer$(Teil$(Daten$, "Daten.V[1].Direkt"))
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.V[1].Name")
    GOSUB LaTeXTabelle
    Text$ = FuerNutzer$(Teil$(Daten$, "Daten.V[1].ZP2"))
    GOSUB LaTeXTabelleSonderzeichen
    Text$ = FuerNutzer$(Teil$(Daten$, "Daten.V[2].ZP1"))
    GOSUB LaTeXTabelleSonderzeichen
    Text$ = FuerNutzer$(Teil$(Daten$, "Daten.V[2].Direkt"))
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.V[2].Name")
    GOSUB LaTeXTabelle
    Text$ = FuerNutzer$(Teil$(Daten$, "Daten.V[2].ZP2"))
    GOSUB LaTeXTabelleSonderzeichen
    Text$ = Teil$(Daten$, "Daten.Quelle")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[1].Tol1")
    GOSUB LaTeXTabelleSonderzeichen
    Text$ = Teil$(Daten$, "Daten.B[1].Datum.Jahr")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[1].Datum.JS")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[1].Datum.Monat")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[1].Datum.MS")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[1].Datum.Tag")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[1].Datum.TS")
    GOSUB LaTeXTabelle
    Text$ = FuerNutzer$(Teil$(Daten$, "Daten.B[1].ZP1"))
    GOSUB LaTeXTabelleSonderzeichen
    Text$ = Teil$(Daten$, "Daten.B[1].Name")
    GOSUB LaTeXAusgabe
    PRINT #Drucken%, " \\"
    IF (z& - 1) MOD Zeilen% = Zeilen% - 1 OR z& = GEL& THEN
      PRINT #Drucken%, "\hline"
      PRINT #Drucken%, "\end{tabular} \hspace*{\fill}"
      IF Zeilen% = 100 THEN
        PRINT #Drucken%, "\end{tiny}"
      ELSE
        PRINT #Drucken%, "\end{scriptsize}"
      END IF
    END IF
  NEXT z&
 
  FOR z& = 1 TO GEL&
    Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
    IF (z& - 1) MOD Zeilen% = 0 THEN
      PRINT #Drucken%, "\newpage"
      Text$ = "Inhalt (3/3) von " + RTRIM$(LEFT$(EingabeDatei$, 8))
      Text$ = Text$ + ".HQL ("
      Zahl& = ((z& - 1) - ((z& - 1) MOD Zeilen%)) / Zeilen% + 1
      Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "/"
      Zahl& = ((GEL& - 1) - ((GEL& - 1) MOD Zeilen%)) / Zeilen% + 1
      Text$ = Text$ + LTRIM$(STR$(Zahl&)) + "):"
      GOSUB LaTeXAusgabe
      PRINT #Drucken%, "\\"
      IF Zeilen% = 100 THEN
        PRINT #Drucken%, "\begin{tiny}"
      ELSE
        PRINT #Drucken%, "\begin{scriptsize}"
      END IF
      PRINT #Drucken%, "\setlength{\rightmargin}{\leftmargin}"
      Text$ = "\begin{tabular}{|c@{\hspace{0.5em}}c@{\hspace{0.5em}}r@{}l"
      Text$ = Text$ + "@{\hspace{0.5em}}r@{}l@{\hspace{0.5em}}r@{}l|l|"
      Text$ = Text$ + "c@{\hspace{0.5em}}r@{}l@{\hspace{0.5em}}r@{}l"
      Text$ = Text$ + "@{\hspace{0.5em}}r@{}l|c@{\hspace{0.5em}}l|"
      Text$ = Text$ + "c@{\hspace{0.5em}}c@{\hspace{0.5em}}r@{}l"
      Text$ = Text$ + "@{\hspace{0.5em}}"
      Text$ = Text$ + "r@{}l@{\hspace{1em}}r@{}l|l@{\hspace{1em}}l|l|}"
      Text$ = Text$ + " \hline"
      PRINT #Drucken%, Text$
      PRINT #Drucken%, "\multicolumn{8}{|c}{1.Dauer} &"
      PRINT #Drucken%, "\multicolumn{1}{|c}{2.Quelle} &"
      PRINT #Drucken%, "\multicolumn{7}{|c}{2.Bezugsdatum} &"
      PRINT #Drucken%, "\multicolumn{2}{|c}{2.Bezugsname} &"
      PRINT #Drucken%, "\multicolumn{8}{|c}{2.Dauer} &"
      PRINT #Drucken%, "\multicolumn{2}{|c}{Zugleich} &"
      PRINT #Drucken%, "\multicolumn{1}{|c|}{3.Quelle} \\"
      PRINT #Drucken%, "\hline"
    ELSEIF (z& - 1) MOD (Zeilen% / 10) = 0 THEN
      PRINT #Drucken%, "\hline"
    END IF
    Text$ = FuerNutzer$(Teil$(Daten$, "Daten.B[1].ZP2"))
    GOSUB LaTeXTabelleSonderzeichen
    Text$ = Teil$(Daten$, "Daten.B[1].Tol2")
    GOSUB LaTeXTabelleSonderzeichen
    Text$ = Teil$(Daten$, "Daten.B[1].Dauer.Jahr")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[1].Dauer.JS")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[1].Dauer.Monat")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[1].Dauer.MS")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[1].Dauer.Tag")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[1].Dauer.TS")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[1].Quelle")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[2].Tol1")
    GOSUB LaTeXTabelleSonderzeichen
    Text$ = Teil$(Daten$, "Daten.B[2].Datum.Jahr")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[2].Datum.JS")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[2].Datum.Monat")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[2].Datum.MS")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[2].Datum.Tag")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[2].Datum.TS")
    GOSUB LaTeXTabelle
    Text$ = FuerNutzer$(Teil$(Daten$, "Daten.B[2].ZP1"))
    GOSUB LaTeXTabelleSonderzeichen
    Text$ = Teil$(Daten$, "Daten.B[2].Name")
    GOSUB LaTeXTabelle
    Text$ = FuerNutzer$(Teil$(Daten$, "Daten.B[2].ZP2"))
    GOSUB LaTeXTabelleSonderzeichen
    Text$ = Teil$(Daten$, "Daten.B[2].Tol2")
    GOSUB LaTeXTabelleSonderzeichen
    Text$ = Teil$(Daten$, "Daten.B[2].Dauer.Jahr")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[2].Dauer.JS")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[2].Dauer.Monat")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[2].Dauer.MS")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[2].Dauer.Tag")
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[2].Dauer.TS")
    GOSUB LaTeXTabelle
    Gleichzeitig$ = FuerNutzer$(Teil$(Daten$, "Daten.Gleichzeitig"))
    Text$ = LEFT$(Gleichzeitig$, 3)
    GOSUB LaTeXTabelle
    Text$ = RIGHT$(Gleichzeitig$, 2)
    GOSUB LaTeXTabelle
    Text$ = Teil$(Daten$, "Daten.B[2].Quelle")
    GOSUB LaTeXAusgabe
    PRINT #Drucken%, " \\"
    IF (z& - 1) MOD Zeilen% = Zeilen% - 1 OR z& = GEL& THEN
      PRINT #Drucken%, "\hline"
      PRINT #Drucken%, "\end{tabular}"
      IF Zeilen% = 100 THEN
        PRINT #Drucken%, "\end{tiny}"
      ELSE
        PRINT #Drucken%, "\end{scriptsize}"
      END IF
    END IF
  NEXT z&
 
  'Tests der einzelnen Schriftzeichen:
  '----------------------------------'
  'PRINT #Drucken%, "\begin{tiny}"
  'FOR x% = 0 TO 255
  '  Text$ = CHR$(x%)
  '  GOSUB LaTeXAusgabe
  '  IF x% MOD 16 = 15 THEN
  '    PRINT #Drucken%, " \\"
  '  END IF
  'NEXT x%
  'PRINT #Drucken%, "\end{tiny}"
RETURN 'LaTeXdateiErstellen _________________________________________________'

'==========='
LaTeXAusgabe:
'==========='
  Kopie$ = ""
  FOR y% = 1 TO LEN(Text$)
    ascii% = ASC(MID$(Text$, y%, 1))
    SELECT CASE ascii%
    CASE 0 TO 2, 7 TO 15, 28
      A$ = "\{" + LTRIM$(STR$(ascii%)) + "\}"
    CASE 3
      A$ = "\ensuremath{\mathrm{\heartsuit}}"
    CASE 4
      A$ = "\ensuremath{\mathrm{\diamondsuit}}"
    CASE 5
      A$ = "\ensuremath{\mathrm{\clubsuit}}"
    CASE 6
      A$ = "\ensuremath{\mathrm{\spadesuit}}"
    CASE 16
      A$ = "\ensuremath{\mathrm{\rhd}}"
    CASE 17
      A$ = "\ensuremath{\mathrm{\lhd}}"
    CASE 18
      A$ = "\ensuremath{\mathrm{\updownarrow}}"
    CASE 19
      A$ = "!\rule{-0.15em}{0ex}!"
    CASE 20
      A$ = "\P"
    CASE 21
      A$ = "\S"
    CASE 22
      A$ = "\rule{0.25em}{0ex}\rule{0.5em}{1ex}\rule{0.25em}{0ex}"
    CASE 23
      A$ = "\underline{\ensuremath{\mathrm{\updownarrow}}}"
    CASE 24
      A$ = "\ensuremath{\mathrm{\uparrow}}"
    CASE 25
      A$ = "\ensuremath{\mathrm{\downarrow}}"
    CASE 26
      A$ = "\ensuremath{\mathrm{\rightarrow}}"
    CASE 27
      A$ = "\ensuremath{\mathrm{\leftarrow}}"
    CASE 29
      A$ = "\ensuremath{\mathrm{\leftrightarrow}}"
    CASE 30
      A$ = "\ensuremath{\mathrm{\bigtriangleup}}"
    CASE 31
      A$ = "\ensuremath{\mathrm{\bigtriangledown}}"
    CASE 32
      A$ = "\rule{0.5em}{0ex}"  '"\hspace{0.5em}" wirkt ungenauer!
    CASE 34, 42, 94, 126
      A$ = "\symbol{" + LTRIM$(STR$(ascii%)) + "}"
    CASE 35 TO 38, 95, 123, 125
      A$ = "\" + CHR$(ascii%)
    CASE 60, 62
      A$ = "\ensuremath{\mathrm{" + CHR$(ascii%) + "}}"
    CASE 92
      A$ = "\ensuremath{\mathrm{\backslash}}"
    CASE 124
      A$ = "\ensuremath{\mathrm{\mid}}"
    CASE 127
      A$ = "\ensuremath{\mathrm{\Delta}}"
    CASE 155, 157, 169 TO 172, 176 TO 218, 244 TO 245
      A$ = "\{" + LTRIM$(STR$(ascii%)) + "\}"
    CASE 168
      A$ = "?`"
    CASE 173
      A$ = "!`"
    CASE 219
      A$ = "\rule[-0.9ex]{1em}{2.9ex}"
    CASE 220
      A$ = "\rule[-0.9ex]{1em}{1.45ex}"
    CASE 221
      A$ = "\rule[-0.9ex]{0.5em}{2.9ex}\rule{0.5em}{0ex}"
    CASE 222
      A$ = "\rule{0.5em}{0ex}\rule[-0.9ex]{0.5em}{2.9ex}"
    CASE 223
      A$ = "\rule[0.55ex]{1em}{1.45ex}"
    CASE 226
      A$ = "\symbol{0}"
    CASE 224, 226 TO 243, 246 TO 247, 251 TO 253
      A$ = "\ensuremath{\mathrm{" + CHR$(ascii%) + "}}"
    CASE 249
      A$ = "\ensuremath{\mathrm{\bullet}}"
    CASE 250
      A$ = "\ensuremath{\mathrm{\cdot}}"
    CASE 255
      A$ = "\rule{1em}{0ex}"    '"\hspace{1em}" wirkt ungenauer!
    CASE ELSE
      A$ = CHR$(ascii%)         'Mglichst viel Klartext
    END SELECT
    Kopie$ = Kopie$ + A$
  NEXT y%
  PRINT #Drucken%, Kopie$;
RETURN 'LaTeXAusgabe ________________________________________________________'

'========================'
LaTeXAusgabeSonderzeichen:
'========================'
  IF Text$ = SPACE$(1) THEN
    Text$ = CHR$(255)           'ntig wegen \usepackage{latexsym}
  END IF
  GOSUB LaTeXAusgabe
RETURN 'LaTeXAusgabeSonderzeichen ___________________________________________'

'==========='
LaTeXTabelle:
'==========='
  GOSUB LaTeXAusgabe
  PRINT #Drucken%, " & ";
RETURN 'LaTeXTabelle ________________________________________________________'

'========================'
LaTeXTabelleSonderzeichen:
'========================'
  GOSUB LaTeXAusgabeSonderzeichen
  PRINT #Drucken%, " & ";
RETURN 'LaTeXTabelleSonderzeichen ___________________________________________'

'=='
CSV:
'=='
  Text$ = "Ausgabedatei " + LEFT$(EingabeDatei$, 8) + ".CSV wird erstellt."
  Ausgabe 2, Text$, "", 0, "M", 1, 1, 24
  Drucken% = FREEFILE
  Puffer$ = Arbeitsplatz$ + LEFT$(EingabeDatei$, 8) + ".CSV"
  OPEN Puffer$ FOR OUTPUT AS #Drucken%
    
    'berschriften:
    '-------------'
    PRINT #Drucken%, ",";
    Text$ = "Lebensanfang [ * ]"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",,";
    Text$ = "1.Wirkungsanfang [ A ]"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",,";
    Text$ = "2.Wirkungsanfang [ W ]"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",,";
    Text$ = "2.Wirkungsende [ X ]"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",,";
    Text$ = "1.Wirkungsende [ E ]"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",,";
    Text$ = "Lebensende [ + ]"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",";
    Text$ = "Name /Ereignis"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",,";
    Text$ = "1.Vorgnger"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",,,";
    Text$ = "2.Vorgnger"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",";
    Text$ = "1.Quelle"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",";
    Text$ = "1.Bezugsdatum"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",";
    Text$ = "1.Bezugsname"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",,";
    Text$ = "1.Dauer"
    GOSUB CSVAusgabe
    Text$ = "2.Quelle"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",";
    Text$ = "2.Bezugsdatum"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",";
    Text$ = "2.Bezugsname"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ",,";
    Text$ = "2.Dauer"
    GOSUB CSVAusgabe
    Text$ = "Zugleich"
    GOSUB CSVAusgabe
    Text$ = "3.Quelle"
    GOSUB CSVAusgabe
    PRINT #Drucken%, ""

    FOR z& = 1 TO GEL&
      Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
      FOR x% = 1 TO 6
        Variable$ = "Daten.Datum[" + LTRIM$(STR$(x%)) + "]"
        Text$ = Teil$(Daten$, Variable$ + ".Minimum")
        GOSUB CSVAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Status")
        SELECT CASE Text$
        CASE ""
          Text$ = "X"
        CASE ""
          Text$ = ">"
        CASE ""
          Text$ = "<"
        CASE "", ""
          Text$ = " "
        END SELECT
        GOSUB CSVAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Maximum")
        GOSUB CSVAusgabe
      NEXT x%
      Text$ = Teil$(Daten$, "Daten.Name")
      GOSUB CSVAusgabe
      FOR x% = 1 TO 2
        Variable$ = "Daten.V[" + LTRIM$(STR$(x%)) + "]"
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".ZP1"))
        GOSUB CSVAusgabe
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".Direkt"))
        GOSUB CSVAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Name")
        GOSUB CSVAusgabe
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".ZP2"))
        GOSUB CSVAusgabe
      NEXT x%
      Text$ = Teil$(Daten$, "Daten.Quelle")
      GOSUB CSVAusgabe
      FOR x% = 1 TO 2
        Variable$ = "Daten.B[" + LTRIM$(STR$(x%)) + "]"
        Text$ = Teil$(Daten$, Variable$ + ".Tol1")
        GOSUB CSVAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Datum")
        GOSUB CSVAusgabe
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".ZP1"))
        GOSUB CSVAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Name")
        GOSUB CSVAusgabe
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".ZP2"))
        GOSUB CSVAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Tol2")
        GOSUB CSVAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Dauer")
        GOSUB CSVAusgabe
        IF x% = 2 THEN
          Text$ = FuerNutzer$(Teil$(Daten$, "Daten.Gleichzeitig"))
          Text$ = LEFT$(Text$, 3) + " " + RIGHT$(Text$, 2)
          GOSUB CSVAusgabe
        END IF
        Text$ = Teil$(Daten$, Variable$ + ".Quelle")
        GOSUB CSVAusgabe
      NEXT x%
      PRINT #Drucken%, ""
    NEXT z&
  CLOSE #Drucken%
 
  LOCATE 24, 1
  PRINT SPACE$(80);
  Ausgabe 2, "Zum Ansehen Programm verlassen.", "", 0, "M", 1, 1, 24
  Pause
RETURN 'CSV _________________________________________________________________'

'========='
CSVAusgabe:
'========='
  Kopie$ = ""
  FOR y% = 1 TO LEN(Text$)
    ascii% = ASC(MID$(Text$, y%, 1))
    SELECT CASE ascii%
    CASE 20
      A$ = CHR$(182)
    CASE 21
      A$ = CHR$(167)
    CASE 127 TO 254
      IF Html%(ascii% - 126) < 256 THEN
        A$ = CHR$(Html%(ascii% - 126))
      ELSE
        A$ = "<" + LTRIM$(STR$(ascii%)) + ">"
      END IF
    CASE ELSE
      A$ = CHR$(ascii%)
    END SELECT
    Kopie$ = Kopie$ + A$
  NEXT y%
  PRINT #Drucken%, CHR$(34) + Kopie$ + CHR$(34) + ",";
RETURN 'CSVAusgabe __________________________________________________________'

'==='
Html:
'==='
  Text$ = "Ausgabedatei " + LEFT$(EingabeDatei$, 8) + ".HTM wird erstellt."
  Ausgabe 2, Text$, "", 0, "M", 1, 1, 24
  Drucken% = FREEFILE
  Puffer$ = Arbeitsplatz$ + LEFT$(EingabeDatei$, 8) + ".HTM"
  OPEN Puffer$ FOR OUTPUT AS #Drucken%
    PRINT #Drucken%, "<HTML>"
    PRINT #Drucken%, "<HEAD>"
    Align$ = "Title"
    Text$ = EingabeDatei$
    GOSUB HtmlAusgabe
    PRINT #Drucken%, "</HEAD>"
    PRINT #Drucken%, "<BODY><CENTER>"
    PRINT #Drucken%, "<TABLE BORDER=5 CELLSPACING=0 CELLPADDING=2><TR>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=7>  Lebensanfang [ * ]  </TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=7>1.Wirkungsanfang [ A ]</TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=7>2.Wirkungsanfang [ W ]</TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=7> 2.Wirkungsende [ X ] </TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=7> 1.Wirkungsende [ E ] </TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=7>   Lebensende [ + ]   </TH>"
    PRINT #Drucken%, "<TH NOWRAP          >Name /Ereignis        </TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=3>1.Vorg&#228;nger      </TH>"
    PRINT #Drucken%, "<TH NOWRAP          >Was                   </TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=3>2.Vorg&#228;nger      </TH>"
    PRINT #Drucken%, "<TH NOWRAP          >Was                   </TH>"
    PRINT #Drucken%, "<TH NOWRAP          >1.Quelle              </TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=4>1.Bezugsdatum         </TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=2>1.Bezugsname          </TH>"
    PRINT #Drucken%, "<TH NOWRAP          >Was                   </TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=4>1.Dauer               </TH>"
    PRINT #Drucken%, "<TH NOWRAP          >2.Quelle              </TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=4>2.Bezugsdatum         </TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=2>2.Bezugsname          </TH>"
    PRINT #Drucken%, "<TH NOWRAP          >Was                   </TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=4>2.Dauer               </TH>"
    PRINT #Drucken%, "<TH NOWRAP COLSPAN=2>Gleichzeitig          </TH>"
    PRINT #Drucken%, "<TH NOWRAP          >3.Quelle              </TH>"
    PRINT #Drucken%, "</TR>"
    FOR z& = 1 TO GEL&
      Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
      PRINT #Drucken%, "<TR>"
      FOR x% = 1 TO 6
        Align$ = "right"
        Variable$ = "Daten.Datum[" + LTRIM$(STR$(x%)) + "]"
        Text$ = Teil$(Daten$, Variable$ + ".Minimum.Tag")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Minimum.TS")
        GOSUB HtmlAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Minimum.Monat")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Minimum.MS")
        GOSUB HtmlAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Minimum.VZ")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Minimum.Jahr")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Minimum.JS")
        GOSUB HtmlAusgabe
        Align$ = "center"
        Text$ = Teil$(Daten$, Variable$ + ".Status")
        GOSUB HtmlAusgabe
        Align$ = "right"
        Text$ = Teil$(Daten$, Variable$ + ".Maximum.Tag")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Maximum.TS")
        GOSUB HtmlAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Maximum.Monat")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Maximum.MS")
        GOSUB HtmlAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Maximum.VZ")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Maximum.Jahr")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Maximum.JS")
        GOSUB HtmlAusgabe
      NEXT x%
      Align$ = "left"
      Text$ = Teil$(Daten$, "Daten.Name")
      GOSUB HtmlAusgabe
      FOR x% = 1 TO 2
        Variable$ = "Daten.V[" + LTRIM$(STR$(x%)) + "]"
        Align$ = "center"
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".ZP1"))
        GOSUB HtmlAusgabe
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".Direkt"))
        GOSUB HtmlAusgabe
        Align$ = "left"
        Text$ = Teil$(Daten$, Variable$ + ".Name")
        GOSUB HtmlAusgabe
        Align$ = "center"
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".ZP2"))
        GOSUB HtmlAusgabe
      NEXT x%
      Align$ = "left"
      Text$ = Teil$(Daten$, "Daten.Quelle")
      GOSUB HtmlAusgabe
      FOR x% = 1 TO 2
        Variable$ = "Daten.B[" + LTRIM$(STR$(x%)) + "]"
        Align$ = "center"
        Text$ = Teil$(Daten$, Variable$ + ".Tol1")
        GOSUB HtmlAusgabe
        Align$ = "right"
        Text$ = Teil$(Daten$, Variable$ + ".Datum.Jahr")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Datum.JS")
        GOSUB HtmlAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Datum.Monat")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Datum.MS")
        GOSUB HtmlAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Datum.Tag")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Datum.TS")
        GOSUB HtmlAusgabe
        Align$ = "center"
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".ZP1"))
        GOSUB HtmlAusgabe
        Align$ = "left"
        Text$ = Teil$(Daten$, Variable$ + ".Name")
        GOSUB HtmlAusgabe
        Align$ = "center"
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".ZP2"))
        GOSUB HtmlAusgabe
        Align$ = "right"
        Text$ = Teil$(Daten$, Variable$ + ".Tol2")
        GOSUB HtmlAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Dauer.Jahr")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Dauer.JS")
        GOSUB HtmlAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Dauer.Monat")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Dauer.MS")
        GOSUB HtmlAusgabe
        Text$ = Teil$(Daten$, Variable$ + ".Dauer.Tag")
        Text$ = Text$ + Teil$(Daten$, Variable$ + ".Dauer.TS")
        GOSUB HtmlAusgabe
        Align$ = "left"
        IF x% = 2 THEN
          Text$ = FuerNutzer$(LEFT$(Teil$(Daten$, "Daten.Gleichzeitig"), 3))
          Kopie$ = LEFT$(Text$, 1) + " " + MID$(Text$, 2, 1)
          Kopie$ = Kopie$ + " " + RIGHT$(Text$, 1)
          Text$ = Kopie$
          GOSUB HtmlAusgabe
          Text$ = FuerNutzer$(RIGHT$(Teil$(Daten$, "Daten.Gleichzeitig"), 2))
          Kopie$ = LEFT$(Text$, 1) + " " + RIGHT$(Text$, 1)
          GOSUB HtmlAusgabe
        END IF
        Text$ = Teil$(Daten$, Variable$ + ".Quelle")
        GOSUB HtmlAusgabe
      NEXT x%


      PRINT #Drucken%, "</TR>"
    NEXT z&
    PRINT #Drucken%, "</TABLE></CENTER>"
    'PRINT #Drucken%, "<TABLE BORDER=2><TR>"
    'FOR x% = 0 TO 255
    '  IF x% > 0 AND x% MOD 16 = 0 THEN
    '    PRINT #Drucken%, "</TR><TR>"
    '  END IF
    '  Text$ = STR$(x%) + ":" + CHR$(x%)
    '  GOSUB HtmlAusgabe
    'NEXT x%
    'PRINT #Drucken%, "</TR></TABLE>"
    'FOR l& = 0 TO 31'65536
    '  PRINT #Drucken%, STR$(l&); ":&#"; LTRIM$(STR$(l&)); " "
    'NEXT l&
    PRINT #Drucken%, "</BODY></HTML>"
  CLOSE #Drucken%
 
  LOCATE 24, 1
  PRINT SPACE$(80);
  Ausgabe 2, "Zum Ansehen Programm verlassen.", "", 0, "M", 1, 1, 24
  Pause
RETURN 'HTML ________________________________________________________________'

'=========='
HtmlAusgabe:
'=========='
  Kopie$ = ""
  FOR y% = 1 TO LEN(Text$)
    ascii% = ASC(MID$(Text$, y%, 1))
    SELECT CASE ascii%
    CASE 1, 2
      A$ = "&#" + LTRIM$(STR$(9785 + ascii%)) + ";"
    CASE 3, 4
      A$ = "&#" + LTRIM$(STR$(9826 + ascii%)) + ";"
    CASE 5
      A$ = "&#9827;"
    CASE 6
      A$ = "&#9824;"
    CASE 7
      A$ = "&#9679;"
    CASE 8
      A$ = "&#9688;"
    CASE 9
      A$ = "&#9675;"
    CASE 10
      A$ = "&#9689;"
    CASE 11
      A$ = "&#9794;"
    CASE 12
      A$ = "&#9792;"
    CASE 13, 14
      A$ = "&#" + LTRIM$(STR$(9821 + ascii%)) + ";"
    CASE 15
      A$ = "&#9788;"
    CASE 16
      A$ = "&#9658;"
    CASE 17
      A$ = "&#9668;"
    CASE 18
      A$ = "&#8597;"
    CASE 19
      A$ = "&#8252;"
    CASE 20
      A$ = "&#182;"
    CASE 21
      A$ = "&#167;"
    CASE 22
      A$ = "&#9644;"
    CASE 23
      A$ = "&#8616;"
    CASE 24
      A$ = "&#8593;"
    CASE 25
      A$ = "&#8595;"
    CASE 26
      A$ = "&#8594;"
    CASE 27
      A$ = "&#8592;"
    CASE 28
      A$ = "&#8735;"
    CASE 29
      A$ = "&#8596;"
    CASE 30
      A$ = "&#9650;"
    CASE 31
      A$ = "&#9660;"
    CASE 34, 35, 38, 60, 62     'HTML-Steuerzeichen
      A$ = "&#" + LTRIM$(STR$(ascii%)) + ";"
    CASE 127 TO 254
      A$ = "&#" + LTRIM$(STR$(Html%(ascii% - 126))) + ";"
    CASE 0, 255
      A$ = " "                  'In echte Leerzeichen wandeln!
    CASE ELSE
      A$ = CHR$(ascii%)         'Mglichst viel Klartext
    END SELECT
    Kopie$ = Kopie$ + A$
  NEXT y%
  IF UCASE$(Align$) = "TITLE" THEN
    PRINT #Drucken%, "<TITLE>" + Kopie$ + "</TITLE>"
  ELSE
    PRINT #Drucken%, "<TD NOWRAP ALIGN=" + Align$ + ">" + Kopie$ + "</TD>"
  END IF
RETURN 'HTMLAusgabe _________________________________________________________'

'=========='
Mathematica:
'=========='
  Text$ = "Ausgabedatei " + LEFT$(EingabeDatei$, 8) + ".m wird erstellt."
  Ausgabe 2, Text$, "", 0, "M", 1, 1, 24
  Drucken% = FREEFILE
  Puffer$ = Arbeitsplatz$ + LEFT$(EingabeDatei$, 8) + ".m"
  OPEN Puffer$ FOR OUTPUT AS #Drucken%
    PRINT #Drucken%, "{"
    PRINT #Drucken%, "Daten["
    FOR x% = 1 TO 6
      PRINT #Drucken%, "Datum[" + LTRIM$(STR$(x%)) + "]["
      PRINT #Drucken%, "T1[VZ[],Jahr[],JS[],Monat[],MS[],Tag[],TS[]],"
      PRINT #Drucken%, "Status[],";
      PRINT #Drucken%, "T2[VZ[],Jahr[],JS[],Monat[],MS[],Tag[],TS[]]"
      PRINT #Drucken%, "],"
    NEXT x%
    PRINT #Drucken%, "Name[],"
    FOR x% = 1 TO 2
      PRINT #Drucken%, "V[" + LTRIM$(STR$(x%)) + "]["
      PRINT #Drucken%, "ZP1[],Direkt[],Name[],ZP2[]"
      PRINT #Drucken%, "],"
    NEXT x%
    PRINT #Drucken%, "Quelle[],"
    FOR x% = 1 TO 2
      PRINT #Drucken%, "B[" + LTRIM$(STR$(x%)) + "]["
      PRINT #Drucken%, "Tol1[],Datum[Jahr[],JS[],Monat[],MS[],Tag[],TS[]],"
      PRINT #Drucken%, "ZP1[],Name[],ZP2[],"
      PRINT #Drucken%, "Tol2[],Dauer[Jahr[],JS[],Monat[],MS[],Tag[],TS[]],"
      IF x% = 2 THEN
        PRINT #Drucken%, "Gleichzeitig[Fall1[],Fall2[]],"
      END IF
      PRINT #Drucken%, "Quelle[]"
      PRINT #Drucken%, "]";
      IF x% = 1 THEN
        PRINT #Drucken%, ",";
      END IF
    NEXT x%
    PRINT #Drucken%, "],"

    FOR z& = 1 TO GEL&
      Daten$ = Laden$(Eingabe%, DatenLaenge%, GEL&, z&)
      PRINT #Drucken%, "{";
      FOR x% = 1 TO 6
        Variable$ = "Daten.Datum[" + LTRIM$(STR$(x%)) + "]"
        PRINT #Drucken%, "{";
        Text$ = Teil$(Daten$, Variable$ + ".Minimum")
        GOSUB MathematicaDatum
        PRINT #Drucken%, ","
        Text$ = Teil$(Daten$, Variable$ + ".Status")
        SELECT CASE Text$
        CASE ""
          Text$ = "X"
        CASE ""
          Text$ = ">"
        CASE ""
          Text$ = "<"
        CASE ELSE
          Text$ = SPACE$(1)
        END SELECT
        GOSUB MathematicaListe
        Text$ = Teil$(Daten$, Variable$ + ".Maximum")
        GOSUB MathematicaDatum
        PRINT #Drucken%, "},"
      NEXT x%
      Text$ = Teil$(Daten$, "Daten.Name")
      GOSUB MathematicaListe
      FOR x% = 1 TO 2
        Variable$ = "Daten.V[" + LTRIM$(STR$(x%)) + "]"
        PRINT #Drucken%, "{";
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".ZP1"))
        GOSUB MathematicaListe
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".Direkt"))
        GOSUB MathematicaListe
        Text$ = Teil$(Daten$, Variable$ + ".Name")
        GOSUB MathematicaListe
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".ZP2"))
        GOSUB MathematicaAusgabe
        PRINT #Drucken%, "},"
      NEXT x%
      Text$ = Teil$(Daten$, "Daten.Quelle")
      GOSUB MathematicaListe
      FOR x% = 1 TO 2
        Variable$ = "Daten.B[" + LTRIM$(STR$(x%)) + "]"
        PRINT #Drucken%, "{";
        Text$ = Teil$(Daten$, Variable$ + ".Tol1")
        GOSUB MathematicaListe
        Text$ = Teil$(Daten$, Variable$ + ".Datum")
        GOSUB MathematicaDauer
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".ZP1"))
        GOSUB MathematicaListe
        Text$ = Teil$(Daten$, Variable$ + ".Name")
        GOSUB MathematicaListe
        Text$ = FuerNutzer$(Teil$(Daten$, Variable$ + ".ZP2"))
        GOSUB MathematicaListe
        Text$ = Teil$(Daten$, Variable$ + ".Tol2")
        GOSUB MathematicaListe
        Text$ = Teil$(Daten$, Variable$ + ".Dauer")
        GOSUB MathematicaDauer
        IF x% = 2 THEN
          PRINT #Drucken%, "{";
          Text$ = FuerNutzer$(LEFT$(Teil$(Daten$, "Daten.Gleichzeitig"), 3))
          GOSUB MathematicaListe
          Text$ = FuerNutzer$(RIGHT$(Teil$(Daten$, "Daten.Gleichzeitig"), 2))
          GOSUB MathematicaAusgabe
          PRINT #Drucken%, "},"
        END IF
        Text$ = Teil$(Daten$, Variable$ + ".Quelle")
        GOSUB MathematicaAusgabe
        IF x% = 1 THEN
          PRINT #Drucken%, "},"
        ELSE
          PRINT #Drucken%, "}"
        END IF
      NEXT x%
      IF z& = GEL& THEN
        PRINT #Drucken%, "}"
      ELSE
        PRINT #Drucken%, "},"
      END IF
    NEXT z&

    PRINT #Drucken%, "}"
  CLOSE #Drucken%

  LOCATE 24, 1
  PRINT SPACE$(80);
  Ausgabe 2, "Zum Ansehen Programm verlassen.", "", 0, "M", 1, 1, 24
  Pause

RETURN 'Mathematica _________________________________________________________'

'==============='
MathematicaDatum:
'==============='
  PRINT #Drucken%, "{" + LTRIM$(Teil$(Text$, "Termin.VZ"));
  PRINT #Drucken%, LTRIM$(Teil$(Text$, "Termin.Jahr")) + ",";
  PRINT #Drucken%, CHR$(34) + RTRIM$(LTRIM$(Teil$(Text$, "Termin.JS")));
  PRINT #Drucken%, CHR$(34) + ",";
  PRINT #Drucken%, LTRIM$(Teil$(Text$, "Termin.Monat")) + ",";
  PRINT #Drucken%, CHR$(34) + RTRIM$(LTRIM$(Teil$(Text$, "Termin.MS")));
  PRINT #Drucken%, CHR$(34) + ",";
  PRINT #Drucken%, LTRIM$(Teil$(Text$, "Termin.Tag")) + ",";
  PRINT #Drucken%, CHR$(34) + RTRIM$(LTRIM$(Teil$(Text$, "Termin.TS")));
  PRINT #Drucken%, CHR$(34) + "}";
RETURN 'MathematicaDatum ____________________________________________________'

'==============='
MathematicaDauer:
'==============='
  PRINT #Drucken%, "{" + LTRIM$(Teil$(Text$, "Zeitpunkt.Jahr")) + ",";
  PRINT #Drucken%, CHR$(34) + RTRIM$(LTRIM$(Teil$(Text$, "Zeitpunkt.JS")));
  PRINT #Drucken%, CHR$(34) + ",";
  PRINT #Drucken%, LTRIM$(Teil$(Text$, "Zeitpunkt.Monat")) + ",";
  PRINT #Drucken%, CHR$(34) + RTRIM$(LTRIM$(Teil$(Text$, "Zeitpunkt.MS")));
  PRINT #Drucken%, CHR$(34) + ",";
  PRINT #Drucken%, LTRIM$(Teil$(Text$, "Zeitpunkt.Tag")) + ",";
  PRINT #Drucken%, CHR$(34) + RTRIM$(LTRIM$(Teil$(Text$, "Zeitpunkt.TS")));
  PRINT #Drucken%, CHR$(34) + "},";
RETURN 'MathematicaDauer ____________________________________________________'

'==============='
MathematicaListe:
'==============='
  GOSUB MathematicaAusgabe
  PRINT #Drucken%, ",";
RETURN 'MathematicaListe ____________________________________________________'

'================='
MathematicaAusgabe:
'================='
  Text$ = RTRIM$(LTRIM$(Text$))
  Kopie$ = ""
  FOR y% = 1 TO LEN(Text$)
    ascii% = ASC(MID$(Text$, y%, 1))
    SELECT CASE ascii%
    CASE 1
      A$ = "\[HappySmiley]"
    CASE 3
      A$ = "\[HeartSuit]"
    CASE 4
      A$ = "\[DiamondSuit]"
    CASE 5
      A$ = "\[ClubSuit]"
    CASE 6
      A$ = "\[SpadeSuit]"
    CASE 7
      A$ = "\[FilledSmallCircle]"
    CASE 9
      A$ = "\[EmptyCircle]"
    CASE 15
      A$ = "\[LightBulb]"
    CASE 16
      A$ = "\[RightTriangle]"
    CASE 17
      A$ = "\[LeftTriangle]"
    CASE 18
      A$ = "\[UpDownArrow]"
    CASE 19
      A$ = "!\[NegativeMediumSpace]!"
    CASE 20
      A$ = "\[Paragraph]"
    CASE 21
      A$ = "\[Section]"
    CASE 24
      A$ = "\[UpArrow]"
    CASE 25
      A$ = "\[DownArrow]"
    CASE 26
      A$ = "\[RightArrow]"
    CASE 27
      A$ = "\[LeftArrow]"
    CASE 29
      A$ = "\[LeftRightArrow]"
    CASE 30
      A$ = "\[FilledUpTriangle]"
    CASE 31
      A$ = "\[FilledDownTriangle]"
    CASE 32, 255
      A$ = SPACE$(1)
    CASE 34
      A$ = "\" + CHR$(34)
    CASE 92
      A$ = "\[Backslash]"
    CASE 127
      A$ = "\[CapitalDelta]"
    CASE 128
      A$ = "\[CapitalCCedilla]"
    CASE 129
      A$ = "\[UDoubleDot]"
    CASE 130
      A$ = "\[EAcute]"
    CASE 131
      A$ = "\[AHat]"
    CASE 132
      A$ = "\[ADoubleDot]"
    CASE 133
      A$ = "\[AGrave]"
    CASE 134
      A$ = "\[ARing]"
    CASE 135
      A$ = "\[CCedilla]"
    CASE 136
      A$ = "\[EHat]"
    CASE 137
      A$ = "\[EDoubleDot]"
    CASE 138
      A$ = "\[EGrave]"
    CASE 139
      A$ = "\[IDoubleDot]"
    CASE 140
      A$ = "\[IHat]"
    CASE 141
      A$ = "\[IGrave]"
    CASE 142
      A$ = "\[CapitalADoubleDot]"
    CASE 143
      A$ = "\[CapitalARing]"
    CASE 144
      A$ = "\[CapitalEAcute]"
    CASE 145
      A$ = "\[AE]"
    CASE 146
      A$ = "\[CapitalAE]"
    CASE 147
      A$ = "\[OHat]"
    CASE 148
      A$ = "\[ODoubleDot]"
    CASE 149
      A$ = "\[OGrave]"
    CASE 150
      A$ = "\[UHat]"
    CASE 151
      A$ = "\[UGrave]"
    CASE 152
      A$ = "\[YDoubleDot]"
    CASE 153
      A$ = "\[CapitalODoubleDot]"
    CASE 154
      A$ = "\[CapitalUDoubleDot]"
    CASE 155
      A$ = "\[Cent]"
    CASE 156
      A$ = "\[Sterling]"
    CASE 157
      A$ = "\[Yen]"
    CASE 159
      A$ = "\[Florin]"
    CASE 160
      A$ = "\[AAcute]"
    CASE 161
      A$ = "\[IAcute]"
    CASE 162
      A$ = "\[OAcute]"
    CASE 163
      A$ = "\[UAcute]"
    CASE 164
      A$ = "\[NTilde]"
    CASE 165
      A$ = "\[CapitalNTilde]"
    CASE 168
      A$ = "\[DownQuestion]"
    CASE 170
      A$ = "\[Not]"
    CASE 173
      A$ = "\[DownExclamation]"
    CASE 174
      A$ = "\[LeftGuillemet]"
    CASE 175
      A$ = "\[RightGuillemet]"
    CASE 224
      A$ = "\[Alpha]"
    CASE 225
      A$ = "\[SZ]"
    CASE 226
      A$ = "\[CapitalGamma]"
    CASE 227
      A$ = "\[Pi]"
    CASE 228
      A$ = "\[CapitalSigma]"
    CASE 229
      A$ = "\[Sigma]"
    CASE 230
      A$ = "\[Micro]"
    CASE 231
      A$ = "\[Gamma]"
    CASE 232
      A$ = "\[CapitalPhi]"
    CASE 233
      A$ = "\[Theta]"
    CASE 234
      A$ = "\[CapitalOmega]"
    CASE 235
      A$ = "\[Delta]"
    CASE 236
      A$ = "\[Infinity]"
    CASE 237
      A$ = "\[OSlash]"
    CASE 238
      A$ = "\[Epsilon]"
    CASE 239
      A$ = "\[Intersection]"
    CASE 240
      A$ = "\[Congruent]"
    CASE 241
      A$ = "\[PlusMinus]"
    CASE 242
      A$ = "\[GreaterEqual]"
    CASE 243
      A$ = "\[LessEqual]"
    CASE 246
      A$ = "\[Divide]"
    CASE 247
      A$ = "\[TildeTilde]"
    CASE 248
      A$ = "\[Degree]"
    CASE 249
      A$ = "\[Bullet]"
    CASE 250
      A$ = "\[CenterDot]"
    CASE 251
      A$ = "\[Sqrt]"
    CASE 254
      A$ = "\[FilledRectangle]"
    CASE 127 TO 254
      A$ = LCASE$(HEX$(Html%(ascii% - 126)))
      IF LEN(A$) = 2 THEN
        A$ = "\." + A$
      ELSE
        A$ = "\:" + STRING$(4 - LEN(A$), ASC("0")) + A$
      END IF
    CASE ELSE
      A$ = CHR$(ascii%)
    END SELECT
    Kopie$ = Kopie$ + A$
  NEXT y%
  PRINT #Drucken%, CHR$(34) + Kopie$ + CHR$(34);
RETURN 'MathematicaAusgabe __________________________________________________'

'============================================================================'
SUB Ausgabe (Farbe%, Frage$, Puffer$, Offset%, Art$, Bereich%, Bereiche%, y%)
'============================================================================'
  ' Gibt `Frage$` gefolgt von `Puffer$` in Zeile `y%` aus.
  '
  ' Bedeutung der weiteren bergebenen Parameter:
  ' `Farbe%`    Wahlmodus 1 (normal) oder 2 (hervorgehoben)
  ' `Offset%`   Verschiebungsmglichkeit innerhalb einer Spalte
  ' `Bereich%`  Gewnschte Spalte
  ' `Bereiche%` Spaltenzahl insgesamt
  ' `Art$`      "L" (linksbndig), "M" (mittenzentriert), "R" (rechtsbndig)
  '
  ' Bearbeitung:
  '  7. 8.2001 -  4. 9.2001: Norbert Sdland und Eckhard Walter, Adelshofen
  '--------------------------------------------------------------------------'
  DIM Laenge%   'AS INTEGER
  DIM x%


  SELECT CASE Farbe%
    CASE 1
      COLOR 7, 0
    CASE 2
      COLOR 15, 0
  END SELECT
  Laenge% = LEN(Frage$) + LEN(Puffer$) + 2
  IF LEN(Puffer$) = 0 THEN
    Laenge% = Laenge% - 2
  END IF
  IF Laenge% > 80 / Bereiche% THEN
    Laenge% = 80 / Bereiche%
    IF LEN(Frage$) >= Laenge% THEN      'Programmier-Ungereimtheit!
      Frage$ = LEFT$(Frage$, Laenge%)
      Puffer$ = ""
    ELSE
      Pause
      Puffer$ = LEFT$(Puffer$, LEN(Frage$) - Laenge%)
    END IF
  END IF

  SELECT CASE Art$
  CASE "L"
    x% = INT(Offset% + (Bereich% - 1) * 80 / Bereiche%)
  CASE "M"
    x% = INT(Offset% + (Bereich% - .5) * 80 / Bereiche% - Laenge% / 2) + 1
  CASE "R"
    x% = INT(Offset% + Bereich% * 80 / Bereiche% - Laenge%)
  END SELECT
  LOCATE y%, x%
  PRINT Frage$;

  IF Puffer$ <> "" THEN
    COLOR 0, 7
    SELECT CASE Farbe%
      CASE 1
        PRINT " "; Puffer$; " ";
      CASE 2
        IF Puffer$ <> "" THEN
          x% = POS(0)
          LOCATE y%, x% + 1
          PRINT Puffer$;
        END IF
    END SELECT
  END IF

  COLOR 7, 0
END SUB 'Ausgabe ____________________________________________________________'

'================================'
  FUNCTION FuerNutzer$ (Symbol$)
'================================'
  ' Wandelt die internationale 'Symbol$'-Kodierung in deutschen Nutzer-Kode.
  ' Diese Funktion arbeitet auch mit alten Daten-Dateien korrekt.
  '
  ' Bearbeitung:
  ' 20.11.2007 - 22.11.2007:    Norbert Sdland, D-73431 Aalen
  '
  ' bersetzung:
  ' 14. 2.2009:                 Norbert Sdland, D-73431 Aalen
  '--------------------------------------------------------------------------'
  DIM Ergebnis$
  DIM Zaehler%

  Ergebnis$ = SPACE$(LEN(Symbol$))
  FOR Zaehler% = 1 TO LEN(Symbol$)
    SELECT CASE MID$(Symbol$, Zaehler%, 1)
    CASE "1", "J", "Y"
      MID$(Ergebnis$, Zaehler%, 1) = "J"        'Ja
    CASE "0", "N"
      MID$(Ergebnis$, Zaehler%, 1) = "N"        'Nein
    CASE "{", "*"
      MID$(Ergebnis$, Zaehler%, 1) = "*"        'Geburt
    CASE "[", "A", "B"
      MID$(Ergebnis$, Zaehler%, 1) = "A"        '1.Wirkungsanfang
    CASE "(", "W", ""
      MID$(Ergebnis$, Zaehler%, 1) = "W"        '2.Wirkungsanfang
    CASE ")", "X", ""
      MID$(Ergebnis$, Zaehler%, 1) = "X"        '2.Wirkungsende
    CASE "]", "E"
      MID$(Ergebnis$, Zaehler%, 1) = "E"        '1.Wirkungsende
    CASE "}", "+"
      MID$(Ergebnis$, Zaehler%, 1) = "+"        'Lebensende
    CASE ELSE
      MID$(Ergebnis$, Zaehler%, 1) = SPACE$(1)
    END SELECT
  NEXT Zaehler%

  FuerNutzer$ = Ergebnis$
END FUNCTION 'FuerNutzer$ ___________________________________________________'

'====================================================================='
  FUNCTION Laden$ (Datei%, DatensatzLaenge%, DateiLaenge&, Position&)
'====================================================================='
  ' Liest den `Position&`-ten Eintrag einer Binr-`Datei%`, die
  ' `DateiLaenge&` Eintrge der Zeichenlnge `DatensatzLaenge%` besitzt.
  ' Der 0-te Eintrag der Datei wird zur Dokumentation verwendet.
  '
  ' Bearbeitung:
  '  4. 8.2001 - 20. 1.2003:      Norbert Sdland
  '--------------------------------------------------------------------------'
  DIM Feld$     'AS STRING
  DIM l%        'AS INTEGER


  Feld$ = SPACE$(DatensatzLaenge%)
  IF Position& = 0 THEN
    Position& = DateiLaenge&
  END IF
  GET #Datei%, Position& * DatensatzLaenge% + 1, Feld$

  Laden$ = Feld$
END FUNCTION 'Laden$ ________________________________________________________'

'==========='
  SUB Pause
'==========='
  ' Blendet in Zeile 25 eine Ansage ein und wartet auf einen Tastendruck.
  ' Macht eine Pause und gibt die Mglichkeit zur Unterbrechung des Programms
  '  mit Einsicht in den Programmtext.
  ' Der Befehl STOP arbeitet unter Windows XP nicht immer zuverlssig.
  '
  ' Bearbeitung:
  ' 18. 8.2001 Norbert Sdland und Eckhard Walter, Adelshofen
  '  4. 9.2001: Norbert Sdland, Mnchen
  ' 10.10.2016: Norbert Sdland, Aalen
  '--------------------------------------------------------------------------'
  DIM Antwort$  'AS STRING
  DIM x%        'AS INTEGER
  DIM y%


  'Aktuelle Cursor-Position ermitteln:
  '----------------------------------'
  x% = CSRLIN
  y% = POS(0)
 
  'Zeile 25 lschen und beschriften:
  '--------------------------------'
  COLOR 7, 0
  LOCATE 25, 1
  PRINT SPACE$(80);
  LOCATE 25, 6
  COLOR 0, 7
  PRINT " Weiter mit Tastendruck ";
  COLOR 15, 0
  PRINT " Programmkode ansehen: ";
  COLOR 0, 7
  IF ENVIRON$("COMSPEC") = "Z:\COMMAND.COM" THEN
    PRINT " [ Strg ] - [ Rollen ] ";
  ELSE
    PRINT " [ Strg ] - [ Pause ] ";
  END IF
  COLOR 7, 0
 
  'Tastendruck abwarten:
  '--------------------'
  Antwort$ = Taste$

  'Zeile 25 erneut lschen:
  '-----------------------'
  LOCATE 25, 1, 1
  PRINT SPACE$(80);

  'Cursor-Position restaurieren:
  '----------------------------'
  LOCATE x%, y%
END SUB 'Pause ______________________________________________________________'

'=============================================='
  FUNCTION SchnellePosition% (Liste$(), Name$)
'=============================================='
  ' Sucht in `Liste$()` nach `Name$`
  ' - Es wird vorausgesetzt, da die `Liste()` alphabetisch sortiert ist,
  '   wobei alle Sonderzeichen nach ihren ASCII-Nummern behandelt werden.
  ' - Das Ergebnis ist eindeutig, wenn der `Name$` maximal einmal in der
  '   `Liste$()` vorkommt.
  ' - Die interne Indexierung der `Liste$()` bleibt unbercksichtigt.
  '
  ' Bearbeitung:
  '  4. 8.2001 - 27.12.2002:    Norbert Sdland
  ' berprfung:
  '--------------------------------------------------------------------------'
  DIM SuchBeginn%       'AS INTEGER
  DIM SuchEnde%
  DIM Gefunden%
  DIM Probe%

 
  SuchBeginn% = LBOUND(Liste$)
  SuchEnde% = UBOUND(Liste$)
  Gefunden% = 0
  WHILE Gefunden% = 0 AND SuchBeginn% <= SuchEnde%
    Probe% = INT(SuchBeginn% / 2 + SuchEnde% / 2)       'berlauf verhindert!
    SELECT CASE Liste$(Probe%)
    CASE IS < Name$
      SuchBeginn% = Probe% + 1
    CASE IS = Name$
      Gefunden% = Probe%
    CASE IS > Name$
      SuchEnde% = Probe% - 1
    END SELECT
  WEND

  SchnellePosition% = Gefunden%
END FUNCTION 'SchnellePosition% _____________________________________________'

'=================================='
  FUNCTION SIZEOF% (StrukturName$)
'=================================='
  ' Gibt die Lnge der Datenstruktur namens `StrukturName$` zurck.
  '
  ' Bearbeitung:
  '  4. 8.2001 - 12. 2.2003:    Norbert Sdland
  ' berprfung:
  ' 12. 2.2003:                 Norbert Sdland
  '--------------------------------------------------------------------------'
  DIM StrukturPosition%         'AS INTEGER
  DIM StrukturLaenge%           'AS INTEGER


  StrukturPosition% = SchnellePosition%(GVName$(), StrukturName$)
  IF StrukturPosition% = 0 THEN
    Pause
    StrukturLaenge% = 0         'Name nicht gefunden: Schreibfehler?
  ELSE
  
    'Gespeicherte Strukturlnge lesen:
    '--------------------------------'
    StrukturLaenge% = GVLaenge%(StrukturPosition%)

    IF StrukturLaenge% <= 0 THEN
      Pause
      ERROR 190         'Nicht-Positive Strukturlnge abgespeichert!
    END IF
  END IF

  SIZEOF% = StrukturLaenge%
END FUNCTION 'SIZEOF% _______________________________________________________'

'========================================'
  FUNCTION STRLEN% (Text$, EndeZeichen$)
'========================================'
  ' Ermittelt die Stringlnge von `Text$` bis zum ersten Auftreten aller
  ' `EndeZeichen$`, so wie es in der Programmiersprache C blich ist.
  ' Kommt `Ende` nicht vor, wird die Stringlnge `LEN(Text$)` zurckgegeben.
  '
  ' Bearbeitung:
  '  4. 8.2001:   Norbert Sdland, Mnchen
  ' berprfung:
  '  4. 8.2001:   Norbert Sdland, Mnchen
  '--------------------------------------------------------------------------'
  DIM ZwischenErgebnis%         'AS INTEGER

  ZwischenErgebnis% = INSTR(Text$, EndeZeichen$)
  IF ZwischenErgebnis% = 0 THEN
    ZwischenErgebnis% = LEN(Text$)
  ELSE
    ZwischenErgebnis% = ZwischenErgebnis% - 1
  END IF

  STRLEN% = ZwischenErgebnis%
END FUNCTION 'STRLEN% _______________________________________________________'

'================='
  FUNCTION Taste$
'================='
  ' Wartet auf einen Tastendruck und liefert das entsprechende ASCII-Zeichen.
  '
  ' Bearbeitung:
  ' 18. 8.2001: Norbert Sdland und Eckhard Walter, Adelshofen
  ' berprfung:
  ' 18. 8.2001: Norbert Sdland und Eckhard Walter, Adelshofen
  '  6. 9.2002: Norbert Sdland, Aalen
  '--------------------------------------------------------------------------'
  DIM Antwort$          'AS STRING


  'Tastaturpuffer lschen:
  '----------------------'
  WHILE INKEY$ <> ""
  WEND

  'Tastatur erneut abfragen, bis ein Zeichen geschrieben wurde:
  '-----------------------------------------------------------'
  Antwort$ = ""
  WHILE LEN(Antwort$) = 0
    Antwort$ = INKEY$
  WEND

  'Ergebnis:
  '--------'
  Taste$ = Antwort$
END FUNCTION 'Taste$ ________________________________________________________'

'===================================='
  FUNCTION Teil$ (Daten$, Variable$)
'===================================='
  '
  ' Bearbeitung:
  '  4. 8.2001 -  4. 9.2001:    Norbert Sdland, Mnchen
  '--------------------------------------------------------------------------'
  DIM Suche$    'AS STRING
  DIM Erg$
  DIM Weitersuche$
  DIM l%        'AS INTEGER
  DIM P%
  DIM Wo%


  l% = LEN(Variable$)
  P% = STRLEN%(Variable$, ".") + 1
  IF P% = l% THEN
    Suche$ = Variable$
  ELSE
    P% = P% + STRLEN%(MID$(Variable$, P% + 1, l% - P%), ".") + 1
    IF P% < l% THEN
      Suche$ = LEFT$(Variable$, P% - 1)
    ELSE
      Suche$ = Variable$
    END IF
  END IF
  Wo% = SchnellePosition%(GVName$(), Suche$)
  IF Wo% = 0 THEN
    Erg$ = ""
  ELSE
    Erg$ = MID$(Daten$, GVAnfang%(Wo%), GVLaenge%(Wo%))
    IF P% < l% THEN
      Weitersuche$ = GVTyp$(Wo%) + MID$(Variable$, P%, l% - P% + 1)
      Erg$ = Teil$(Erg$, Weitersuche$)
    END IF
  END IF
  Teil$ = Erg$
END FUNCTION 'Teil$ _________________________________________________________'

